## linux-gcp 6.19.0-1001.1

=== rust/Makefile ===
# SPDX-License-Identifier: GPL-2.0

# Where to place rustdoc generated documentation
rustdoc_output := $(objtree)/Documentation/output/rust/rustdoc

obj-$(CONFIG_RUST) += core.o compiler_builtins.o ffi.o
always-$(CONFIG_RUST) += exports_core_generated.h

# Missing prototypes are expected in the helpers since these are exported
# for Rust only, thus there is no header nor prototypes.
obj-$(CONFIG_RUST) += helpers/helpers.o
CFLAGS_REMOVE_helpers/helpers.o = -Wmissing-prototypes -Wmissing-declarations

always-$(CONFIG_RUST) += bindings/bindings_generated.rs bindings/bindings_helpers_generated.rs
obj-$(CONFIG_RUST) += bindings.o pin_init.o kernel.o
always-$(CONFIG_RUST) += exports_helpers_generated.h \
    exports_bindings_generated.h exports_kernel_generated.h

always-$(CONFIG_RUST) += uapi/uapi_generated.rs
obj-$(CONFIG_RUST) += uapi.o

ifdef CONFIG_RUST_BUILD_ASSERT_ALLOW
obj-$(CONFIG_RUST) += build_error.o
else
always-$(CONFIG_RUST) += build_error.o
endif

obj-$(CONFIG_RUST) += exports.o

always-$(CONFIG_RUST) += libproc_macro2.rlib libquote.rlib libsyn.rlib

always-$(CONFIG_RUST_KERNEL_DOCTESTS) += doctests_kernel_generated.rs
always-$(CONFIG_RUST_KERNEL_DOCTESTS) += doctests_kernel_generated_kunit.c

obj-$(CONFIG_RUST_KERNEL_DOCTESTS) += doctests_kernel_generated.o
obj-$(CONFIG_RUST_KERNEL_DOCTESTS) += doctests_kernel_generated_kunit.o

always-$(subst y,$(CONFIG_RUST),$(CONFIG_JUMP_LABEL)) += kernel/generated_arch_static_branch_asm.rs
ifndef CONFIG_UML
always-$(subst y,$(CONFIG_RUST),$(CONFIG_BUG)) += kernel/generated_arch_warn_asm.rs kernel/generated_arch_reachable_asm.rs
endif

# Avoids running `$(RUSTC)` when it may not be available.
ifdef CONFIG_RUST

libmacros_name := $(shell MAKEFLAGS= $(RUSTC) --print file-names --crate-name macros --crate-type proc-macro - </dev/null)
libmacros_extension := $(patsubst libmacros.%,%,$(libmacros_name))

libpin_init_internal_name := $(shell MAKEFLAGS= $(RUSTC) --print file-names --crate-name pin_init_internal --crate-type proc-macro - </dev/null)
libpin_init_internal_extension := $(patsubst libpin_init_internal.%,%,$(libpin_init_internal_name))

always-$(CONFIG_RUST) += $(libmacros_name) $(libpin_init_internal_name)

# `$(rust_flags)` is passed in case the user added `--sysroot`.
rustc_sysroot := $(shell MAKEFLAGS= $(RUSTC) $(rust_flags) --version | awk '{print "/usr/src/" $$1 "-" $$2}')
rustc_host_target := $(shell $(RUSTC) --version --verbose | grep -F 'host: ' | cut -d' ' -f2)
RUST_LIB_SRC ?= $(rustc_sysroot)/library

ifneq ($(quiet),)
rust_test_quiet=-q
rustdoc_test_quiet=--test-args -q
rustdoc_test_kernel_quiet=>/dev/null
endif

cfgs-to-flags = $(patsubst %,--cfg='%',$1)

core-cfgs := \
    no_fp_fmt_parse

core-edition := $(if $(call rustc-min-version,108700),2024,2021)

core-skip_flags := \
    --edition=2021 \
    -Wunreachable_pub \
    -Wrustdoc::unescaped_backticks

core-flags := \
    --edition=$(core-edition) \
    $(call cfgs-to-flags,$(core-cfgs))

proc_macro2-cfgs := \
    feature="proc-macro" \
    wrap_proc_macro \
    $(if $(call rustc-min-version,108800),proc_macro_span_file proc_macro_span_location)

# Stable since Rust 1.79.0: `feature(proc_macro_byte_character,proc_macro_c_str_literals)`.
proc_macro2-flags := \
    --cap-lints=allow \
    -Zcrate-attr='feature(proc_macro_byte_character,proc_macro_c_str_literals)' \
    $(call cfgs-to-flags,$(proc_macro2-cfgs))

quote-cfgs := \
    feature="proc-macro"

quote-skip_flags := \
    --edition=2021

quote-flags := \
    --edition=2018 \
    --cap-lints=allow \
    --extern proc_macro2 \
    $(call cfgs-to-flags,$(quote-cfgs))

# `extra-traits`, `fold` and `visit` may be enabled if needed.
syn-cfgs := \
    feature="clone-impls" \
    feature="derive" \
    feature="full" \
    feature="parsing" \
    feature="printing" \
    feature="proc-macro" \
    feature="visit-mut"

syn-flags := \
    --cap-lints=allow \
    --extern proc_macro2 \
    --extern quote \
    $(call cfgs-to-flags,$(syn-cfgs))

# `rustdoc` did not save the target modifiers, thus workaround for
# the time being (https://github.com/rust-lang/rust/issues/144521).
rustdoc_modifiers_workaround := $(if $(call rustc-min-version,108800),-Cunsafe-allow-abi-mismatch=fixed-x18)

# Similarly, for doctests (https://github.com/rust-lang/rust/issues/146465).
doctests_modifiers_workaround := $(rustdoc_modifiers_workaround)$(if $(call rustc-min-version,109100),$(comma)sanitizer)

# `rustc` recognizes `--remap-path-prefix` since 1.26.0, but `rustdoc` only
# since Rust 1.81.0. Moreover, `rustdoc` ICEs on out-of-tree builds since Rust
# 1.82.0 (https://github.com/rust-lang/rust/issues/138520). Thus workaround both
# issues skipping the flag. The former also applies to `RUSTDOC TK`.
quiet_cmd_rustdoc = RUSTDOC $(if $(rustdoc_host),H, ) $<
      cmd_rustdoc = \
	OBJTREE=$(abspath $(objtree)) \
	$(RUSTDOC) $(filter-out $(skip_flags) --remap-path-prefix=%,$(if $(rustdoc_host),$(rust_common_flags),$(rust_flags))) \
		$(rustc_target_flags) -L$(objtree)/$(obj) \
		-Zunstable-options --generate-link-to-definition \
		--output $(rustdoc_output) \
		--crate-name $(subst rustdoc-,,$@) \
		$(rustdoc_modifiers_workaround) \
		$(if $(rustdoc_host),,--sysroot=/dev/null) \
		@$(objtree)/include/generated/rustc_cfg $<

# The `html_logo_url` and `html_favicon_url` forms of the `doc` attribute
# can be used to specify a custom logo. However:
#   - The given value is used as-is, thus it cannot be relative or a local file
#     (unlike the non-custom case) since the generated docs have subfolders.
#   - It requires adding it to every crate.
#   - It requires changing `core` which comes from the sysroot.
#
# Using `-Zcrate-attr` would solve the last two points, but not the first.
# The https://github.com/rust-lang/rfcs/pull/3226 RFC suggests two new
# command-like flags to solve the issue. Meanwhile, we use the non-custom case
# and then retouch the generated files.
rustdoc: rustdoc-core rustdoc-macros rustdoc-compiler_builtins \
    rustdoc-kernel rustdoc-pin_init
	$(Q)grep -Ehro '<a href="srctree/([^"]+)"' $(rustdoc_output) | \
		cut -d'"' -f2 | cut -d/ -f2- | while read f; do \
			if [ ! -e "$(srctree)/$$f" ]; then \
				echo "warning: srctree/ link to $$f does not exist"; \
			fi \
		done
	$(Q)cp $(srctree)/Documentation/images/logo.svg $(rustdoc_output)/static.files/
	$(Q)cp $(srctree)/Documentation/images/COPYING-logo $(rustdoc_output)/static.files/
	$(Q)find $(rustdoc_output) -name '*.html' -type f -print0 | xargs -0 sed -Ei \
		-e 's:rust-logo-[0-9a-f]+\.svg:logo.svg:g' \
		-e 's:favicon-[0-9a-f]+\.svg:logo.svg:g' \
		-e 's:<link rel="alternate icon" type="image/png" href="[/.]+/static\.files/favicon-(16x16|32x32)-[0-9a-f]+\.png">::g' \
		-e 's:<a href="srctree/([^"]+)">:<a href="$(realpath $(srctree))/\1">:g'
	$(Q)for f in $(rustdoc_output)/static.files/rustdoc-*.css; do \
		echo ".logo-container > img { object-fit: contain; }" >> $$f; done

rustdoc-proc_macro2: private rustdoc_host = yes
rustdoc-proc_macro2: private rustc_target_flags = $(proc_macro2-flags)
rustdoc-proc_macro2: $(src)/proc-macro2/lib.rs rustdoc-clean FORCE
	+$(call if_changed,rustdoc)

rustdoc-quote: private rustdoc_host = yes
rustdoc-quote: private rustc_target_flags = $(quote-flags)
rustdoc-quote: private skip_flags = $(quote-skip_flags)
rustdoc-quote: $(src)/quote/lib.rs rustdoc-clean rustdoc-proc_macro2 FORCE
	+$(call if_changed,rustdoc)

rustdoc-syn: private rustdoc_host = yes
rustdoc-syn: private rustc_target_flags = $(syn-flags)
rustdoc-syn: $(src)/syn/lib.rs rustdoc-clean rustdoc-quote FORCE
	+$(call if_changed,rustdoc)

rustdoc-macros: private rustdoc_host = yes
rustdoc-macros: private rustc_target_flags = --crate-type proc-macro \
    --extern proc_macro --extern proc_macro2 --extern quote --extern syn
rustdoc-macros: $(src)/macros/lib.rs rustdoc-clean rustdoc-proc_macro2 \
    rustdoc-quote rustdoc-syn FORCE
	+$(call if_changed,rustdoc)

# Starting with Rust 1.82.0, skipping `-Wrustdoc::unescaped_backticks` should
# not be needed -- see https://github.com/rust-lang/rust/pull/128307.
rustdoc-core: private skip_flags = $(core-skip_flags)
rustdoc-core: private rustc_target_flags = $(core-flags)
rustdoc-core: $(RUST_LIB_SRC)/core/src/lib.rs rustdoc-clean FORCE
	+$(call if_changed,rustdoc)

# Even if `rustdoc` targets are not kernel objects, they should still be
# treated as such so that we pass the same flags. Otherwise, for instance,
# `rustdoc` will complain about missing sanitizer flags causing an ABI mismatch.
rustdoc-compiler_builtins: private is-kernel-object := y
rustdoc-compiler_builtins: $(src)/compiler_builtins.rs rustdoc-core FORCE
	+$(call if_changed,rustdoc)

rustdoc-ffi: private is-kernel-object := y
rustdoc-ffi: $(src)/ffi.rs rustdoc-core FORCE
	+$(call if_changed,rustdoc)

rustdoc-pin_init_internal: private rustdoc_host = yes
rustdoc-pin_init_internal: private rustc_target_flags = --cfg kernel \
    --extern proc_macro --crate-type proc-macro
rustdoc-pin_init_internal: $(src)/pin-init/internal/src/lib.rs \
    rustdoc-clean FORCE
	+$(call if_changed,rustdoc)

rustdoc-pin_init: private rustdoc_host = yes
rustdoc-pin_init: private rustc_target_flags = --extern pin_init_internal \
    --extern macros --extern alloc --cfg kernel --cfg feature=\"alloc\"
rustdoc-pin_init: $(src)/pin-init/src/lib.rs rustdoc-pin_init_internal \
    rustdoc-macros FORCE
	+$(call if_changed,rustdoc)

rustdoc-kernel: private is-kernel-object := y
rustdoc-kernel: private rustc_target_flags = --extern ffi --extern pin_init \
    --extern build_error --extern macros \
    --extern bindings --extern uapi
rustdoc-kernel: $(src)/kernel/lib.rs rustdoc-core rustdoc-ffi rustdoc-macros \
    rustdoc-pin_init rustdoc-compiler_builtins $(obj)/$(libmacros_name) \
    $(obj)/bindings.o FORCE
	+$(call if_changed,rustdoc)

rustdoc-clean: FORCE
	$(Q)rm -rf $(rustdoc_output)

quiet_cmd_rustc_test_library = $(RUSTC_OR_CLIPPY_QUIET) TL $<
      cmd_rustc_test_library = \
	OBJTREE=$(abspath $(objtree)) \
	$(RUSTC_OR_CLIPPY) $(filter-out $(skip_flags),$(rust_common_flags) $(rustc_target_flags)) \
		@$(objtree)/include/generated/rustc_cfg \
		--crate-type $(if $(rustc_test_library_proc),proc-macro,rlib) \
		--out-dir $(objtree)/$(obj)/test --cfg testlib \
		-L$(objtree)/$(obj)/test \
		--crate-name $(subst rusttest-,,$(subst rusttestlib-,,$@)) $<

rusttestlib-build_error: $(src)/build_error.rs FORCE
	+$(call if_changed,rustc_test_library)

rusttestlib-ffi: $(src)/ffi.rs FORCE
	+$(call if_changed,rustc_test_library)

rusttestlib-proc_macro2: private rustc_target_flags = $(proc_macro2-flags)
rusttestlib-proc_macro2: $(src)/proc-macro2/lib.rs FORCE
	+$(call if_changed,rustc_test_library)

rusttestlib-quote: private skip_flags = $(quote-skip_flags)
rusttestlib-quote: private rustc_target_flags = $(quote-flags)
rusttestlib-quote: $(src)/quote/lib.rs rusttestlib-proc_macro2 FORCE
	+$(call if_changed,rustc_test_library)

rusttestlib-syn: private rustc_target_flags = $(syn-flags)
rusttestlib-syn: $(src)/syn/lib.rs rusttestlib-quote FORCE
	+$(call if_changed,rustc_test_library)

rusttestlib-macros: private rustc_target_flags = --extern proc_macro \
    --extern proc_macro2 --extern quote --extern syn
rusttestlib-macros: private rustc_test_library_proc = yes
rusttestlib-macros: $(src)/macros/lib.rs \
    rusttestlib-proc_macro2 rusttestlib-quote rusttestlib-syn FORCE
	+$(call if_changed,rustc_test_library)

rusttestlib-pin_init_internal: private rustc_target_flags = --cfg kernel \
    --extern proc_macro
rusttestlib-pin_init_internal: private rustc_test_library_proc = yes
rusttestlib-pin_init_internal: $(src)/pin-init/internal/src/lib.rs FORCE
	+$(call if_changed,rustc_test_library)

rusttestlib-pin_init: private rustc_target_flags = --extern pin_init_internal \
    --extern macros --cfg kernel
rusttestlib-pin_init: $(src)/pin-init/src/lib.rs rusttestlib-macros \
    rusttestlib-pin_init_internal $(obj)/$(libpin_init_internal_name) FORCE
	+$(call if_changed,rustc_test_library)

=== ubuntu/Makefile ===
#
# Makefile for the Linux kernel ubuntu supplied third-party device drivers.
#

#
# NOTE: to allow drivers to be added and removed without causing merge
# collisions you should add new entries in the middle of the six lines
# of ## at the bottom of the list.  Always add three lines of ## above
# your new entry and maintain the six lines below.
#

##
##
##
obj-$(CONFIG_UBUNTU_HOST)      += ubuntu-host/
##
##
##
obj-$(CONFIG_IGH_ECAT)         += igh-ecat/
##
##
##

=== arch/powerpc/Makefile ===
# This file is included by the global makefile so that you can add your own
# architecture-specific flags and dependencies.
#
# This file is subject to the terms and conditions of the GNU General Public
# License.  See the file "COPYING" in the main directory of this archive
# for more details.
#
# Copyright (C) 1994 by Linus Torvalds
# Changes for PPC by Gary Thomas
# Rewritten by Cort Dougan and Paul Mackerras
#

ifdef cross_compiling
  ifeq ($(CROSS_COMPILE),)
    # Auto detect cross compiler prefix.
    # Look for: (powerpc(64(le)?)?)(-unknown)?-linux(-gnu)?-
    CC_ARCHES := powerpc powerpc64 powerpc64le
    CC_SUFFIXES := linux linux-gnu unknown-linux-gnu
    CROSS_COMPILE := $(call cc-cross-prefix, $(foreach a,$(CC_ARCHES), \
                       $(foreach s,$(CC_SUFFIXES),$(a)-$(s)-)))
  endif
endif

HAS_BIARCH	:= $(call cc-option-yn, -m32)

# Set default 32 bits cross compilers for vdso and boot wrapper
CROSS32_COMPILE ?=

# If we're on a ppc/ppc64/ppc64le machine use that defconfig, otherwise just use
# ppc64le_defconfig because we have nothing better to go on.
uname := $(shell uname -m)
KBUILD_DEFCONFIG := $(if $(filter ppc%,$(uname)),$(uname),ppc64le)_defconfig

new_nm := $(shell if $(NM) --help 2>&1 | grep -- '--synthetic' > /dev/null; then echo y; else echo n; fi)

ifeq ($(new_nm),y)
NM		:= $(NM) --synthetic
endif

# BITS is used as extension for files which are available in a 32 bit
# and a 64 bit version to simplify shared Makefiles.
# e.g.: obj-y += foo_$(BITS).o
export BITS

ifdef CONFIG_PPC64
        BITS := 64
else
        BITS := 32
endif

machine-y = ppc
machine-$(CONFIG_PPC64) += 64
machine-$(CONFIG_CPU_LITTLE_ENDIAN) += le
UTS_MACHINE := $(subst $(space),,$(machine-y))

ifeq ($(CONFIG_PPC64)$(CONFIG_LD_IS_BFD),yy)
# Have the linker provide sfpr if possible.
# There is a corresponding test in arch/powerpc/lib/Makefile
KBUILD_LDFLAGS_MODULE += --save-restore-funcs
else
KBUILD_LDFLAGS_MODULE += $(objtree)/arch/powerpc/lib/crtsavres.o
endif

ifdef CONFIG_CPU_LITTLE_ENDIAN
KBUILD_CPPFLAGS	+= -mlittle-endian
KBUILD_LDFLAGS	+= -EL
LDEMULATION	:= lppc
GNUTARGET	:= powerpcle
MULTIPLEWORD	:= -mno-multiple
KBUILD_CFLAGS_MODULE += $(call cc-option,-mno-save-toc-indirect)
else
KBUILD_CPPFLAGS	+= $(call cc-option,-mbig-endian)
KBUILD_LDFLAGS	+= -EB
LDEMULATION	:= ppc
GNUTARGET	:= powerpc
MULTIPLEWORD	:= -mmultiple
endif

ifdef CONFIG_PPC64
ifndef CONFIG_CC_IS_CLANG
cflags-$(CONFIG_PPC64_ELF_ABI_V1)	+= $(call cc-option,-mabi=elfv1)
cflags-$(CONFIG_PPC64_ELF_ABI_V1)	+= $(call cc-option,-mcall-aixdesc)
aflags-$(CONFIG_PPC64_ELF_ABI_V1)	+= $(call cc-option,-mabi=elfv1)
aflags-$(CONFIG_PPC64_ELF_ABI_V2)	+= -mabi=elfv2
endif
endif

ifndef CONFIG_CC_IS_CLANG
  cflags-$(CONFIG_CPU_LITTLE_ENDIAN)	+= -mno-strict-align
endif

cflags-$(CONFIG_CPU_BIG_ENDIAN)		+= $(call cc-option,-mbig-endian)
cflags-$(CONFIG_CPU_LITTLE_ENDIAN)	+= -mlittle-endian
aflags-$(CONFIG_CPU_BIG_ENDIAN)		+= $(call cc-option,-mbig-endian)
aflags-$(CONFIG_CPU_LITTLE_ENDIAN)	+= -mlittle-endian

ifeq ($(HAS_BIARCH),y)
KBUILD_CPPFLAGS	+= -m$(BITS)
KBUILD_AFLAGS	+= -m$(BITS)
KBUILD_LDFLAGS	+= -m elf$(BITS)$(LDEMULATION)
endif

LDFLAGS_vmlinux-y := -Bstatic
LDFLAGS_vmlinux-$(CONFIG_RELOCATABLE) := -pie --no-dynamic-linker
LDFLAGS_vmlinux-$(CONFIG_RELOCATABLE) += -z notext
LDFLAGS_vmlinux	:= $(LDFLAGS_vmlinux-y)

ifdef CONFIG_PPC64
ifndef CONFIG_PPC_KERNEL_PCREL
	# -mcmodel=medium breaks modules because it uses 32bit offsets from
	# the TOC pointer to create pointers where possible. Pointers into the
	# percpu data area are created by this method.
	#
	# The kernel module loader relocates the percpu data section from the
	# original location (starting with 0xd...) to somewhere in the base
	# kernel percpu data space (starting with 0xc...). We need a full
	# 64bit relocation for this to work, hence -mcmodel=large.
	KBUILD_CFLAGS_MODULE += -mcmodel=large
endif
endif

CFLAGS-$(CONFIG_PPC64)	:= $(call cc-option,-mtraceback=no)
ifdef CONFIG_PPC64_ELF_ABI_V2
CFLAGS-$(CONFIG_PPC64)	+= $(call cc-option,-mabi=elfv2,$(call cc-option,-mcall-aixdesc))
else
ifndef CONFIG_CC_IS_CLANG
CFLAGS-$(CONFIG_PPC64)	+= $(call cc-option,-mabi=elfv1)
CFLAGS-$(CONFIG_PPC64)	+= $(call cc-option,-mcall-aixdesc)
endif
endif
CFLAGS-$(CONFIG_PPC64)	+= -mcmodel=medium
CFLAGS-$(CONFIG_PPC64)	+= $(call cc-option,-mno-pointers-to-nested-functions)
CFLAGS-$(CONFIG_PPC64)	+= $(call cc-option,-mlong-double-128)

# Clang unconditionally reserves r2 on ppc32 and does not support the flag
# https://llvm.org/pr39555
CFLAGS-$(CONFIG_PPC32)	:= $(call cc-option, -ffixed-r2)

# Clang doesn't support -mmultiple / -mno-multiple
# https://llvm.org/pr39556
CFLAGS-$(CONFIG_PPC32)	+= $(call cc-option, $(MULTIPLEWORD))

CFLAGS-$(CONFIG_PPC32)	+= $(call cc-option,-mno-readonly-in-sdata)

CC_FLAGS_FPU		:= $(call cc-option,-mhard-float)
CC_FLAGS_NO_FPU		:= $(call cc-option,-msoft-float)

ifdef CONFIG_FUNCTION_TRACER
ifdef CONFIG_ARCH_USING_PATCHABLE_FUNCTION_ENTRY
KBUILD_CPPFLAGS	+= -DCC_USING_PATCHABLE_FUNCTION_ENTRY
ifdef CONFIG_PPC_FTRACE_OUT_OF_LINE
CC_FLAGS_FTRACE := -fpatchable-function-entry=1
else
ifdef CONFIG_DYNAMIC_FTRACE_WITH_CALL_OPS # PPC32 only
CC_FLAGS_FTRACE := -fpatchable-function-entry=3,1
else
CC_FLAGS_FTRACE := -fpatchable-function-entry=2
endif
endif
else
CC_FLAGS_FTRACE := -pg
ifdef CONFIG_MPROFILE_KERNEL
CC_FLAGS_FTRACE += -mprofile-kernel
endif
endif
endif

CFLAGS-$(CONFIG_TARGET_CPU_BOOL) += -mcpu=$(CONFIG_TARGET_CPU)
AFLAGS-$(CONFIG_TARGET_CPU_BOOL) += -mcpu=$(CONFIG_TARGET_CPU)

CFLAGS-y += $(CONFIG_TUNE_CPU)

asinstr := $(call as-instr,lis 9$(comma)foo@high,-DHAVE_AS_ATHIGH=1)

KBUILD_CPPFLAGS	+= -I $(srctree)/arch/powerpc $(asinstr)
KBUILD_AFLAGS	+= $(AFLAGS-y)
KBUILD_CFLAGS	+= $(CC_FLAGS_NO_FPU)
KBUILD_CFLAGS	+= $(CFLAGS-y)

CHECKFLAGS	+= -m$(BITS) -D__powerpc__ -D__powerpc$(BITS)__
ifdef CONFIG_CPU_BIG_ENDIAN
CHECKFLAGS	+= -D__BIG_ENDIAN__
else
CHECKFLAGS	+= -D__LITTLE_ENDIAN__
endif

ifdef CONFIG_476FPE_ERR46
	KBUILD_LDFLAGS_MODULE += --ppc476-workaround \
		-T $(srctree)/arch/powerpc/platforms/44x/ppc476_modules.lds
endif

# No prefix or pcrel
ifdef CONFIG_PPC_KERNEL_PREFIXED
KBUILD_CFLAGS += $(call cc-option,-mprefixed)
else
KBUILD_CFLAGS += $(call cc-option,-mno-prefixed)
endif
ifdef CONFIG_PPC_KERNEL_PCREL
KBUILD_CFLAGS += $(call cc-option,-mpcrel)
else
KBUILD_CFLAGS += $(call cc-option,-mno-pcrel)
endif

# No AltiVec or VSX or MMA instructions when building kernel
KBUILD_CFLAGS += $(call cc-option,-mno-altivec)
KBUILD_CFLAGS += $(call cc-option,-mno-vsx)
KBUILD_CFLAGS += $(call cc-option,-mno-mma)

# No SPE instruction when building kernel
# (We use all available options to help semi-broken compilers)
KBUILD_CFLAGS += $(call cc-option,-mno-spe)
KBUILD_CFLAGS += $(call cc-option,-mspe=no)

# Don't emit .eh_frame since we have no use for it
KBUILD_CFLAGS += -fno-asynchronous-unwind-tables

# Never use string load/store instructions as they are
# often slow when they are implemented at all
KBUILD_CFLAGS		+= $(call cc-option,-mno-string)

KBUILD_AFLAGS += $(aflags-y)
KBUILD_CFLAGS += $(cflags-y)

# Default to zImage, override when needed
all: zImage

# With make 3.82 we cannot mix normal and wildcard targets
BOOT_TARGETS1 := zImage zImage.initrd uImage vmlinux.strip
BOOT_TARGETS2 := zImage% dtbImage% treeImage.% cuImage.% simpleImage.% uImage.%

PHONY += $(BOOT_TARGETS1) $(BOOT_TARGETS2)

boot := arch/powerpc/boot

$(BOOT_TARGETS1): vmlinux
	$(Q)$(MAKE) $(build)=$(boot) $(patsubst %,$(boot)/%,$@)
$(BOOT_TARGETS2): vmlinux
	$(Q)$(MAKE) $(build)=$(boot) $(patsubst %,$(boot)/%,$@)


PHONY += bootwrapper_install
bootwrapper_install:
	$(Q)$(MAKE) $(build)=$(boot) $(patsubst %,$(boot)/%,$@)

include $(srctree)/scripts/Makefile.defconf

generated_configs += ppc64le_defconfig
ppc64le_defconfig:
	$(call merge_into_defconfig,ppc64_defconfig,le)

generated_configs += ppc64le_guest_defconfig
ppc64le_guest_defconfig:
	$(call merge_into_defconfig,ppc64_defconfig,le guest kvm_guest)

generated_configs += ppc64_guest_defconfig
ppc64_guest_defconfig:
	$(call merge_into_defconfig,ppc64_defconfig,be guest kvm_guest)

generated_configs += pseries_le_defconfig
pseries_le_defconfig: ppc64le_guest_defconfig

generated_configs += pseries_defconfig
pseries_defconfig: ppc64le_guest_defconfig

generated_configs += powernv_be_defconfig
powernv_be_defconfig:
	$(call merge_into_defconfig,powernv_defconfig,be)

generated_configs += mpc85xx_defconfig
mpc85xx_defconfig:
	$(call merge_into_defconfig,mpc85xx_base.config,\
		85xx-32bit 85xx-hw fsl-emb-nonhw)

generated_configs += mpc85xx_smp_defconfig
mpc85xx_smp_defconfig:
	$(call merge_into_defconfig,mpc85xx_base.config,\
		85xx-32bit 85xx-smp 85xx-hw fsl-emb-nonhw)

generated_configs += corenet32_smp_defconfig
corenet32_smp_defconfig:
	$(call merge_into_defconfig,corenet_base.config,\
		85xx-32bit 85xx-smp 85xx-hw fsl-emb-nonhw dpaa)

generated_configs += corenet64_smp_defconfig
corenet64_smp_defconfig:
	$(call merge_into_defconfig,corenet_base.config,\
		85xx-64bit 85xx-smp altivec 85xx-hw fsl-emb-nonhw dpaa)

generated_configs += mpc86xx_defconfig
mpc86xx_defconfig:
	$(call merge_into_defconfig,mpc86xx_base.config,\
		86xx-hw fsl-emb-nonhw)

generated_configs += mpc86xx_smp_defconfig
mpc86xx_smp_defconfig:
	$(call merge_into_defconfig,mpc86xx_base.config,\
		86xx-smp 86xx-hw fsl-emb-nonhw)

generated_configs += ppc32_allmodconfig
ppc32_allmodconfig:
	$(Q)$(MAKE) KCONFIG_ALLCONFIG=$(srctree)/arch/powerpc/configs/book3s_32.config \
		-f $(srctree)/Makefile allmodconfig

generated_configs += ppc44x_allmodconfig
ppc44x_allmodconfig:
	$(Q)$(MAKE) KCONFIG_ALLCONFIG=$(srctree)/arch/powerpc/configs/44x.config \
		-f $(srctree)/Makefile allmodconfig

generated_configs += ppc8xx_allmodconfig
ppc8xx_allmodconfig:
	$(Q)$(MAKE) KCONFIG_ALLCONFIG=$(srctree)/arch/powerpc/configs/8xx.config \
		-f $(srctree)/Makefile allmodconfig

generated_configs += ppc85xx_allmodconfig
ppc85xx_allmodconfig:
	$(Q)$(MAKE) KCONFIG_ALLCONFIG=$(srctree)/arch/powerpc/configs/85xx-32bit.config \
		-f $(srctree)/Makefile allmodconfig

generated_configs += ppc_defconfig
ppc_defconfig:
	$(call merge_into_defconfig,book3s_32.config,)

generated_configs += ppc64le_allmodconfig
ppc64le_allmodconfig:
	$(Q)$(MAKE) KCONFIG_ALLCONFIG=$(srctree)/arch/powerpc/configs/le.config \
		-f $(srctree)/Makefile allmodconfig

generated_configs += ppc64le_allnoconfig
ppc64le_allnoconfig:
	$(Q)$(MAKE) KCONFIG_ALLCONFIG=$(srctree)/arch/powerpc/configs/ppc64le.config \
		-f $(srctree)/Makefile allnoconfig

generated_configs += ppc64_book3e_allmodconfig
ppc64_book3e_allmodconfig:
	$(Q)$(MAKE) KCONFIG_ALLCONFIG=$(srctree)/arch/powerpc/configs/85xx-64bit.config \
		-f $(srctree)/Makefile allmodconfig

generated_configs += ppc32_randconfig
ppc32_randconfig:
	$(Q)$(MAKE) KCONFIG_ALLCONFIG=$(srctree)/arch/powerpc/configs/32-bit.config \
		-f $(srctree)/Makefile randconfig

generated_configs += ppc64_randconfig
ppc64_randconfig:
	$(Q)$(MAKE) KCONFIG_ALLCONFIG=$(srctree)/arch/powerpc/configs/64-bit.config \
		-f $(srctree)/Makefile randconfig

PHONY += $(generated_configs)

define archhelp
  echo '* zImage          - Build default images selected by kernel config'
  echo '  zImage.*        - Compressed kernel image (arch/powerpc/boot/zImage.*)'
  echo '  uImage          - U-Boot native image format'
  echo '  cuImage.<dt>    - Backwards compatible U-Boot image for older'
  echo '                    versions which do not support device trees'
  echo '  dtbImage.<dt>   - zImage with an embedded device tree blob'
  echo '  simpleImage.<dt> - Firmware independent image.'
  echo '  treeImage.<dt>  - Support for older IBM 4xx firmware (not U-Boot)'
  echo '  install         - Install kernel using'
  echo '                    (your) ~/bin/$(INSTALLKERNEL) or'
  echo '                    (distribution) /sbin/$(INSTALLKERNEL) or'
  echo '                    install to $$(INSTALL_PATH)'
  echo '  *_defconfig     - Select default config from arch/powerpc/configs'
  echo ''

=== drivers/android/Makefile ===
# SPDX-License-Identifier: GPL-2.0-only
ccflags-y += -I$(src)			# needed for trace events

binder_linux-y := binder.o binder_alloc.o binder_netlink.o
obj-$(CONFIG_ANDROID_BINDER_IPC) += binder_linux.o
binder_linux-$(CONFIG_ANDROID_BINDERFS) += binderfs.o
binder_linux-$(CONFIG_ANDROID_BINDER_ALLOC_KUNIT_TEST) += binder_alloc_selftest.o
binder_linux-$(CONFIG_ANDROID_BINDER_IPC_RUST)   += binder/

=== drivers/mfd/Makefile ===
# SPDX-License-Identifier: GPL-2.0
#
# Makefile for multifunction miscellaneous devices
#

88pm860x-objs			:= 88pm860x-core.o 88pm860x-i2c.o
obj-$(CONFIG_MFD_88PM860X)	+= 88pm860x.o
obj-$(CONFIG_MFD_88PM800)	+= 88pm800.o 88pm80x.o
obj-$(CONFIG_MFD_88PM805)	+= 88pm805.o 88pm80x.o
obj-$(CONFIG_MFD_88PM886_PMIC)	+= 88pm886.o
obj-$(CONFIG_MFD_ACT8945A)	+= act8945a.o
obj-$(CONFIG_MFD_SM501)		+= sm501.o
obj-$(CONFIG_ARCH_BCM2835)	+= bcm2835-pm.o
obj-$(CONFIG_MFD_BCM590XX)	+= bcm590xx.o
obj-$(CONFIG_MFD_BD9571MWV)	+= bd9571mwv.o
obj-$(CONFIG_MFD_BQ257XX)	+= bq257xx.o
obj-$(CONFIG_MFD_CGBC)		+= cgbc-core.o
obj-$(CONFIG_MFD_CROS_EC_DEV)	+= cros_ec_dev.o
obj-$(CONFIG_MFD_CS42L43)	+= cs42l43.o
obj-$(CONFIG_MFD_CS42L43_I2C)	+= cs42l43-i2c.o
obj-$(CONFIG_MFD_CS42L43_SDW)	+= cs42l43-sdw.o
obj-$(CONFIG_MFD_ENE_KB3930)	+= ene-kb3930.o
obj-$(CONFIG_MFD_EXYNOS_LPASS)	+= exynos-lpass.o
obj-$(CONFIG_MFD_GATEWORKS_GSC)	+= gateworks-gsc.o
obj-$(CONFIG_MFD_MACSMC)	+= macsmc.o

obj-$(CONFIG_MFD_TI_LP873X)	+= lp873x.o
obj-$(CONFIG_MFD_TI_LP87565)	+= lp87565.o
obj-$(CONFIG_MFD_TI_AM335X_TSCADC)	+= ti_am335x_tscadc.o

obj-$(CONFIG_MFD_STMPE)		+= stmpe.o
obj-$(CONFIG_STMPE_I2C)		+= stmpe-i2c.o
obj-$(CONFIG_STMPE_SPI)		+= stmpe-spi.o
obj-$(CONFIG_MFD_SUN6I_PRCM)	+= sun6i-prcm.o
obj-$(CONFIG_MFD_TC3589X)	+= tc3589x.o
obj-$(CONFIG_MFD_TQMX86)	+= tqmx86.o

obj-$(CONFIG_MFD_LOCHNAGAR)	+= lochnagar-i2c.o

arizona-objs			:= arizona-core.o arizona-irq.o
obj-$(CONFIG_MFD_ARIZONA)	+= arizona.o
obj-$(CONFIG_MFD_ARIZONA_I2C)	+= arizona-i2c.o
obj-$(CONFIG_MFD_ARIZONA_SPI)	+= arizona-spi.o
ifeq ($(CONFIG_MFD_WM5102),y)
arizona-objs			+= wm5102-tables.o
endif
ifeq ($(CONFIG_MFD_WM5110),y)
arizona-objs			+= wm5110-tables.o
endif
ifeq ($(CONFIG_MFD_WM8997),y)
arizona-objs			+= wm8997-tables.o
endif
ifeq ($(CONFIG_MFD_WM8998),y)
arizona-objs			+= wm8998-tables.o
endif
ifeq ($(CONFIG_MFD_CS47L24),y)
arizona-objs			+= cs47l24-tables.o
endif
obj-$(CONFIG_MFD_WCD934X)	+= wcd934x.o
obj-$(CONFIG_MFD_WM8400)	+= wm8400-core.o
wm831x-objs			:= wm831x-core.o wm831x-irq.o wm831x-otp.o
wm831x-objs			+= wm831x-auxadc.o
obj-$(CONFIG_MFD_WM831X)	+= wm831x.o
obj-$(CONFIG_MFD_WM831X_I2C)	+= wm831x-i2c.o
obj-$(CONFIG_MFD_WM831X_SPI)	+= wm831x-spi.o
wm8350-objs			:= wm8350-core.o wm8350-regmap.o wm8350-gpio.o
wm8350-objs			+= wm8350-irq.o
obj-$(CONFIG_MFD_WM8350)	+= wm8350.o
obj-$(CONFIG_MFD_WM8350_I2C)	+= wm8350-i2c.o
wm8994-objs			:= wm8994-core.o wm8994-irq.o wm8994-regmap.o
obj-$(CONFIG_MFD_WM8994)	+= wm8994.o
obj-$(CONFIG_MFD_WM97xx)	+= wm97xx-core.o

madera-objs			:= madera-core.o
ifeq ($(CONFIG_MFD_CS47L15),y)
madera-objs			+= cs47l15-tables.o
endif
ifeq ($(CONFIG_MFD_CS47L35),y)
madera-objs			+= cs47l35-tables.o
endif
ifeq ($(CONFIG_MFD_CS47L85),y)
madera-objs			+= cs47l85-tables.o
endif
ifeq ($(CONFIG_MFD_CS47L90),y)
madera-objs			+= cs47l90-tables.o
endif
ifeq ($(CONFIG_MFD_CS47L92),y)
madera-objs			+= cs47l92-tables.o
endif
obj-$(CONFIG_MFD_MADERA)	+= madera.o
obj-$(CONFIG_MFD_MADERA_I2C)	+= madera-i2c.o
obj-$(CONFIG_MFD_MADERA_SPI)	+= madera-spi.o

obj-$(CONFIG_MFD_CS40L50_CORE)	+= cs40l50-core.o
obj-$(CONFIG_MFD_CS40L50_I2C)	+= cs40l50-i2c.o
obj-$(CONFIG_MFD_CS40L50_SPI)	+= cs40l50-spi.o

obj-$(CONFIG_TPS6105X)		+= tps6105x.o
obj-$(CONFIG_TPS65010)		+= tps65010.o
obj-$(CONFIG_TPS6507X)		+= tps6507x.o
obj-$(CONFIG_MFD_TPS65086)	+= tps65086.o
obj-$(CONFIG_MFD_TPS65217)	+= tps65217.o
obj-$(CONFIG_MFD_TPS65218)	+= tps65218.o
obj-$(CONFIG_MFD_TPS65219)	+= tps65219.o
obj-$(CONFIG_MFD_TPS65910)	+= tps65910.o
obj-$(CONFIG_MFD_TPS65912)	+= tps65912-core.o
obj-$(CONFIG_MFD_TPS65912_I2C)	+= tps65912-i2c.o
obj-$(CONFIG_MFD_TPS65912_SPI)  += tps65912-spi.o
obj-$(CONFIG_MFD_TPS6594)	+= tps6594-core.o
obj-$(CONFIG_MFD_TPS6594_I2C)	+= tps6594-i2c.o
obj-$(CONFIG_MFD_TPS6594_SPI)	+= tps6594-spi.o
obj-$(CONFIG_MENELAUS)		+= menelaus.o

obj-$(CONFIG_TWL4030_CORE)	+= twl-core.o twl4030-irq.o twl6030-irq.o
obj-$(CONFIG_TWL4030_POWER)    += twl4030-power.o
obj-$(CONFIG_MFD_TWL4030_AUDIO)	+= twl4030-audio.o
obj-$(CONFIG_TWL6040_CORE)	+= twl6040.o

obj-$(CONFIG_MFD_MX25_TSADC)	+= fsl-imx25-tsadc.o

obj-$(CONFIG_MFD_MC13XXX)	+= mc13xxx-core.o
obj-$(CONFIG_MFD_MC13XXX_SPI)	+= mc13xxx-spi.o
obj-$(CONFIG_MFD_MC13XXX_I2C)	+= mc13xxx-i2c.o

obj-$(CONFIG_MFD_PF1550)	+= pf1550.o

obj-$(CONFIG_MFD_NCT6694)	+= nct6694.o

obj-$(CONFIG_MFD_CORE)		+= mfd-core.o

ocelot-soc-objs			:= ocelot-core.o ocelot-spi.o
obj-$(CONFIG_MFD_OCELOT)	+= ocelot-soc.o

obj-$(CONFIG_EZX_PCAP)		+= ezx-pcap.o
obj-$(CONFIG_MFD_CPCAP)		+= motorola-cpcap.o

obj-$(CONFIG_MCP)		+= mcp-core.o
obj-$(CONFIG_MCP_SA11X0)	+= mcp-sa11x0.o
obj-$(CONFIG_MCP_UCB1200)	+= ucb1x00-core.o
obj-$(CONFIG_MCP_UCB1200_TS)	+= ucb1x00-ts.o

ifeq ($(CONFIG_SA1100_ASSABET),y)
obj-$(CONFIG_MCP_UCB1200)	+= ucb1x00-assabet.o
endif

obj-$(CONFIG_PMIC_DA903X)	+= da903x.o

obj-$(CONFIG_PMIC_DA9052)	+= da9052-irq.o
obj-$(CONFIG_PMIC_DA9052)	+= da9052-core.o
obj-$(CONFIG_MFD_DA9052_SPI)	+= da9052-spi.o
obj-$(CONFIG_MFD_DA9052_I2C)	+= da9052-i2c.o

obj-$(CONFIG_MFD_AC100)		+= ac100.o
obj-$(CONFIG_MFD_AXP20X)	+= axp20x.o
obj-$(CONFIG_MFD_AXP20X_I2C)	+= axp20x-i2c.o
obj-$(CONFIG_MFD_AXP20X_RSB)	+= axp20x-rsb.o

obj-$(CONFIG_MFD_LP3943)	+= lp3943.o
obj-$(CONFIG_MFD_LP8788)	+= lp8788.o lp8788-irq.o

obj-$(CONFIG_MFD_TI_LMU)	+= ti-lmu.o

da9055-objs			:= da9055-core.o da9055-i2c.o
obj-$(CONFIG_MFD_DA9055)	+= da9055.o
obj-$(CONFIG_MFD_DA9062)	+= da9062-core.o
da9063-objs			:= da9063-core.o da9063-irq.o da9063-i2c.o
obj-$(CONFIG_MFD_DA9063)	+= da9063.o
obj-$(CONFIG_MFD_DA9150)	+= da9150-core.o

obj-$(CONFIG_MFD_MAX14577)	+= max14577.o
obj-$(CONFIG_MFD_MAX7360)	+= max7360.o
obj-$(CONFIG_MFD_MAX77541)	+= max77541.o
obj-$(CONFIG_MFD_MAX77620)	+= max77620.o
obj-$(CONFIG_MFD_MAX77650)	+= max77650.o
obj-$(CONFIG_MFD_MAX77686)	+= max77686.o
obj-$(CONFIG_MFD_MAX77693)	+= max77693.o
obj-$(CONFIG_MFD_MAX77705)	+= max77705.o
obj-$(CONFIG_MFD_MAX77714)	+= max77714.o
obj-$(CONFIG_MFD_MAX77759)	+= max77759.o
obj-$(CONFIG_MFD_MAX77843)	+= max77843.o
obj-$(CONFIG_MFD_MAX8907)	+= max8907.o
max8925-objs			:= max8925-core.o max8925-i2c.o
obj-$(CONFIG_MFD_MAX8925)	+= max8925.o
obj-$(CONFIG_MFD_MAX8997)	+= max8997.o max8997-irq.o
obj-$(CONFIG_MFD_MAX8998)	+= max8998.o max8998-irq.o

obj-$(CONFIG_MFD_MP2629)	+= mp2629.o

obj-$(CONFIG_MFD_MT6360)	+= mt6360-core.o
obj-$(CONFIG_MFD_MT6370)	+= mt6370.o
mt6397-objs			:= mt6397-core.o mt6397-irq.o mt6358-irq.o
obj-$(CONFIG_MFD_MT6397)	+= mt6397.o

obj-$(CONFIG_RZ_MTU3)		+= rz-mtu3.o
obj-$(CONFIG_ABX500_CORE)	+= abx500-core.o
obj-$(CONFIG_MFD_DB8500_PRCMU)	+= db8500-prcmu.o
# ab8500-core need to come after db8500-prcmu (which provides the channel)
obj-$(CONFIG_AB8500_CORE)	+= ab8500-core.o ab8500-sysctrl.o
obj-$(CONFIG_MFD_TIMBERDALE)    += timberdale.o
obj-$(CONFIG_PMIC_ADP5520)	+= adp5520.o
obj-$(CONFIG_MFD_ADP5585)	+= adp5585.o
obj-$(CONFIG_MFD_KEMPLD)	+= kempld-core.o
obj-$(CONFIG_MFD_INTEL_QUARK_I2C_GPIO)	+= intel_quark_i2c_gpio.o
obj-$(CONFIG_LPC_SCH)		+= lpc_sch.o
obj-$(CONFIG_LPC_ICH)		+= lpc_ich.o
obj-$(CONFIG_MFD_RDC321X)	+= rdc321x-southbridge.o
obj-$(CONFIG_MFD_JANZ_CMODIO)	+= janz-cmodio.o
obj-$(CONFIG_MFD_TPS6586X)	+= tps6586x.o
obj-$(CONFIG_MFD_VX855)		+= vx855.o

si476x-core-y := si476x-cmd.o si476x-prop.o si476x-i2c.o
obj-$(CONFIG_MFD_SI476X_CORE)	+= si476x-core.o

obj-$(CONFIG_MFD_CS5535)	+= cs5535-mfd.o
obj-$(CONFIG_MFD_OMAP_USB_HOST)	+= omap-usb-host.o omap-usb-tll.o
obj-$(CONFIG_MFD_PM8XXX) 	+= qcom-pm8xxx.o ssbi.o
obj-$(CONFIG_MFD_QCOM_RPM)	+= qcom_rpm.o
obj-$(CONFIG_MFD_SPMI_PMIC)	+= qcom-spmi-pmic.o
obj-$(CONFIG_TPS65911_COMPARATOR)	+= tps65911-comparator.o
obj-$(CONFIG_MFD_TPS65090)	+= tps65090.o
obj-$(CONFIG_MFD_AAT2870_CORE)	+= aat2870-core.o
obj-$(CONFIG_MFD_AT91_USART)	+= at91-usart.o
obj-$(CONFIG_MFD_ATMEL_FLEXCOM)	+= atmel-flexcom.o
obj-$(CONFIG_MFD_ATMEL_HLCDC)	+= atmel-hlcdc.o
obj-$(CONFIG_MFD_ATMEL_SMC)	+= atmel-smc.o
obj-$(CONFIG_MFD_INTEL_LPSS)	+= intel-lpss.o
obj-$(CONFIG_MFD_INTEL_LPSS_PCI)	+= intel-lpss-pci.o
obj-$(CONFIG_MFD_INTEL_LPSS_ACPI)	+= intel-lpss-acpi.o
obj-$(CONFIG_MFD_INTEL_PMC_BXT)	+= intel_pmc_bxt.o
obj-$(CONFIG_MFD_PALMAS)	+= palmas.o
obj-$(CONFIG_MFD_VIPERBOARD)    += viperboard.o
obj-$(CONFIG_MFD_NTXEC)		+= ntxec.o
obj-$(CONFIG_MFD_RC5T583)	+= rc5t583.o rc5t583-irq.o
obj-$(CONFIG_MFD_RK8XX)		+= rk8xx-core.o
obj-$(CONFIG_MFD_RK8XX_I2C)	+= rk8xx-i2c.o
obj-$(CONFIG_MFD_RK8XX_SPI)	+= rk8xx-spi.o
obj-$(CONFIG_MFD_RN5T618)	+= rn5t618.o
sec-core-objs			:= sec-common.o sec-irq.o
obj-$(CONFIG_MFD_SEC_CORE)	+= sec-core.o
obj-$(CONFIG_MFD_SEC_ACPM)	+= sec-acpm.o
obj-$(CONFIG_MFD_SEC_I2C)	+= sec-i2c.o
obj-$(CONFIG_MFD_SYSCON)	+= syscon.o
obj-$(CONFIG_MFD_LM3533)	+= lm3533-core.o lm3533-ctrlbank.o
obj-$(CONFIG_MFD_VEXPRESS_SYSREG)	+= vexpress-sysreg.o
obj-$(CONFIG_MFD_RETU)		+= retu-mfd.o
obj-$(CONFIG_MFD_AS3711)	+= as3711.o
obj-$(CONFIG_MFD_AS3722)	+= as3722.o
obj-$(CONFIG_MFD_STW481X)	+= stw481x.o
obj-$(CONFIG_MFD_IPAQ_MICRO)	+= ipaq-micro.o
obj-$(CONFIG_MFD_IQS62X)	+= iqs62x.o
obj-$(CONFIG_MFD_MENF21BMC)	+= menf21bmc.o
obj-$(CONFIG_MFD_HI6421_PMIC)	+= hi6421-pmic-core.o
obj-$(CONFIG_MFD_HI6421_SPMI)	+= hi6421-spmi-pmic.o
obj-$(CONFIG_MFD_HI655X_PMIC)   += hi655x-pmic.o
obj-$(CONFIG_MFD_DLN2)		+= dln2.o
obj-$(CONFIG_MFD_RT4831)	+= rt4831.o
obj-$(CONFIG_MFD_RT5033)	+= rt5033.o
obj-$(CONFIG_MFD_RT5120)	+= rt5120.o
obj-$(CONFIG_MFD_SKY81452)	+= sky81452.o

obj-$(CONFIG_INTEL_SOC_PMIC)		+= intel_soc_pmic_crc.o
obj-$(CONFIG_INTEL_SOC_PMIC_BXTWC)	+= intel_soc_pmic_bxtwc.o
obj-$(CONFIG_INTEL_SOC_PMIC_CHTWC)	+= intel_soc_pmic_chtwc.o
obj-$(CONFIG_INTEL_SOC_PMIC_CHTDC_TI)	+= intel_soc_pmic_chtdc_ti.o
obj-$(CONFIG_INTEL_SOC_PMIC_MRFLD)	+= intel_soc_pmic_mrfld.o

obj-$(CONFIG_MFD_ALTERA_A10SR)	+= altera-a10sr.o
obj-$(CONFIG_MFD_ALTERA_SYSMGR) += altera-sysmgr.o
obj-$(CONFIG_MFD_STPMIC1)	+= stpmic1.o
obj-$(CONFIG_MFD_SUN4I_GPADC)	+= sun4i-gpadc.o

obj-$(CONFIG_MFD_STM32_LPTIMER)	+= stm32-lptimer.o
obj-$(CONFIG_MFD_STM32_TIMERS) 	+= stm32-timers.o
obj-$(CONFIG_MFD_MXS_LRADC)     += mxs-lradc.o
obj-$(CONFIG_MFD_SC27XX_PMIC)	+= sprd-sc27xx-spi.o
obj-$(CONFIG_RAVE_SP_CORE)	+= rave-sp.o
obj-$(CONFIG_MFD_ROHM_BD71828)	+= rohm-bd71828.o
obj-$(CONFIG_MFD_ROHM_BD718XX)	+= rohm-bd718x7.o
obj-$(CONFIG_MFD_ROHM_BD957XMUF)	+= rohm-bd9576.o
obj-$(CONFIG_MFD_ROHM_BD96801)	+= rohm-bd96801.o
obj-$(CONFIG_MFD_STMFX) 	+= stmfx.o
obj-$(CONFIG_MFD_KHADAS_MCU) 	+= khadas-mcu.o
obj-$(CONFIG_MFD_ACER_A500_EC)	+= acer-ec-a500.o
obj-$(CONFIG_MFD_QCOM_PM8008)	+= qcom-pm8008.o

obj-$(CONFIG_SGI_MFD_IOC3)	+= ioc3.o
obj-$(CONFIG_MFD_SIMPLE_MFD_I2C)	+= simple-mfd-i2c.o
obj-$(CONFIG_MFD_SMPRO)		+= smpro-core.o

obj-$(CONFIG_MFD_INTEL_M10_BMC_CORE)   += intel-m10-bmc-core.o
obj-$(CONFIG_MFD_INTEL_M10_BMC_SPI)    += intel-m10-bmc-spi.o
obj-$(CONFIG_MFD_INTEL_M10_BMC_PMCI)   += intel-m10-bmc-pmci.o

obj-$(CONFIG_MFD_LS2K_BMC_CORE)		+= ls2k-bmc-core.o

obj-$(CONFIG_MFD_ATC260X)	+= atc260x-core.o
obj-$(CONFIG_MFD_ATC260X_I2C)	+= atc260x-i2c.o
obj-$(CONFIG_MFD_AAEON)		+= mfd-aaeon.o

obj-$(CONFIG_MFD_QNAP_MCU)	+= qnap-mcu.o

obj-$(CONFIG_MFD_RSMU_I2C)	+= rsmu_i2c.o rsmu_core.o
obj-$(CONFIG_MFD_RSMU_SPI)	+= rsmu_spi.o rsmu_core.o

obj-$(CONFIG_MFD_UPBOARD_FPGA)	+= upboard-fpga.o

obj-$(CONFIG_MFD_LOONGSON_SE)	+= loongson-se.o

=== tools/sched_ext/Makefile ===
# SPDX-License-Identifier: GPL-2.0
# Copyright (c) 2022 Meta Platforms, Inc. and affiliates.
include ../build/Build.include
include ../scripts/Makefile.arch
include ../scripts/Makefile.include

all: all_targets

ifneq ($(LLVM),)
ifneq ($(filter %/,$(LLVM)),)
LLVM_PREFIX := $(LLVM)
else ifneq ($(filter -%,$(LLVM)),)
LLVM_SUFFIX := $(LLVM)
endif

CLANG_TARGET_FLAGS_arm          := arm-linux-gnueabi
CLANG_TARGET_FLAGS_arm64        := aarch64-linux-gnu
CLANG_TARGET_FLAGS_hexagon      := hexagon-linux-musl
CLANG_TARGET_FLAGS_m68k         := m68k-linux-gnu
CLANG_TARGET_FLAGS_mips         := mipsel-linux-gnu
CLANG_TARGET_FLAGS_powerpc      := powerpc64le-linux-gnu
CLANG_TARGET_FLAGS_riscv        := riscv64-linux-gnu
CLANG_TARGET_FLAGS_s390         := s390x-linux-gnu
CLANG_TARGET_FLAGS_x86          := x86_64-linux-gnu
CLANG_TARGET_FLAGS              := $(CLANG_TARGET_FLAGS_$(ARCH))

ifeq ($(CROSS_COMPILE),)
ifeq ($(CLANG_TARGET_FLAGS),)
$(error Specify CROSS_COMPILE or add '--target=' option to lib.mk)
else
CLANG_FLAGS     += --target=$(CLANG_TARGET_FLAGS)
endif # CLANG_TARGET_FLAGS
else
CLANG_FLAGS     += --target=$(notdir $(CROSS_COMPILE:%-=%))
endif # CROSS_COMPILE

CC := $(LLVM_PREFIX)clang$(LLVM_SUFFIX) $(CLANG_FLAGS) -fintegrated-as
else
CC := $(CROSS_COMPILE)gcc
endif # LLVM

CURDIR := $(abspath .)
TOOLSDIR := $(abspath ..)
LIBDIR := $(TOOLSDIR)/lib
BPFDIR := $(LIBDIR)/bpf
TOOLSINCDIR := $(TOOLSDIR)/include
BPFTOOLDIR := $(TOOLSDIR)/bpf/bpftool
APIDIR := $(TOOLSINCDIR)/uapi
GENDIR := $(abspath ../../include/generated)
GENHDR := $(GENDIR)/autoconf.h

ifeq ($(O),)
OUTPUT_DIR := $(CURDIR)/build
else
OUTPUT_DIR := $(O)/build
endif # O
OBJ_DIR := $(OUTPUT_DIR)/obj
INCLUDE_DIR := $(OUTPUT_DIR)/include
BPFOBJ_DIR := $(OBJ_DIR)/libbpf
SCXOBJ_DIR := $(OBJ_DIR)/sched_ext
BINDIR := $(OUTPUT_DIR)/bin
BPFOBJ := $(BPFOBJ_DIR)/libbpf.a
ifneq ($(CROSS_COMPILE),)
HOST_BUILD_DIR		:= $(OBJ_DIR)/host/obj
HOST_OUTPUT_DIR	:= $(OBJ_DIR)/host
HOST_INCLUDE_DIR	:= $(HOST_OUTPUT_DIR)/include
else
HOST_BUILD_DIR		:= $(OBJ_DIR)
HOST_OUTPUT_DIR	:= $(OUTPUT_DIR)
HOST_INCLUDE_DIR	:= $(INCLUDE_DIR)
endif
HOST_BPFOBJ := $(HOST_BUILD_DIR)/libbpf/libbpf.a
RESOLVE_BTFIDS := $(HOST_BUILD_DIR)/resolve_btfids/resolve_btfids
DEFAULT_BPFTOOL := $(HOST_OUTPUT_DIR)/sbin/bpftool

VMLINUX_BTF_PATHS ?= $(if $(O),$(O)/vmlinux)					\
		     $(if $(KBUILD_OUTPUT),$(KBUILD_OUTPUT)/vmlinux)		\
		     ../../vmlinux						\
		     /sys/kernel/btf/vmlinux					\
		     /boot/vmlinux-$(shell uname -r)
VMLINUX_BTF ?= $(abspath $(firstword $(wildcard $(VMLINUX_BTF_PATHS))))
ifeq ($(VMLINUX_BTF),)
$(error Cannot find a vmlinux for VMLINUX_BTF at any of "$(VMLINUX_BTF_PATHS)")
endif

BPFTOOL ?= $(DEFAULT_BPFTOOL)

ifneq ($(wildcard $(GENHDR)),)
  GENFLAGS := -DHAVE_GENHDR
endif

CFLAGS += -g -O2 -rdynamic -pthread -Wall -Werror $(GENFLAGS)			\
	  -I$(INCLUDE_DIR) -I$(GENDIR) -I$(LIBDIR)				\
	  -I$(TOOLSINCDIR) -I$(APIDIR) -I$(CURDIR)/include

# Silence some warnings when compiled with clang
ifneq ($(LLVM),)
CFLAGS += -Wno-unused-command-line-argument
endif

LDFLAGS += -lelf -lz -lpthread

IS_LITTLE_ENDIAN = $(shell $(CC) -dM -E - </dev/null |				\
			grep 'define __BYTE_ORDER__ __ORDER_LITTLE_ENDIAN__')

# Get Clang's default includes on this system, as opposed to those seen by
# '-target bpf'. This fixes "missing" files on some architectures/distros,
# such as asm/byteorder.h, asm/socket.h, asm/sockios.h, sys/cdefs.h etc.
#
# Use '-idirafter': Don't interfere with include mechanics except where the
# build would have failed anyways.
define get_sys_includes
$(shell $(1) -v -E - </dev/null 2>&1 \
	| sed -n '/<...> search starts here:/,/End of search list./{ s| \(/.*\)|-idirafter \1|p }') \
$(shell $(1) -dM -E - </dev/null | grep '__riscv_xlen ' | awk '{printf("-D__riscv_xlen=%d -D__BITS_PER_LONG=%d", $$3, $$3)}')
endef

BPF_CFLAGS = -g -D__TARGET_ARCH_$(SRCARCH)					\
	     $(if $(IS_LITTLE_ENDIAN),-mlittle-endian,-mbig-endian)		\
	     -I$(CURDIR)/include -I$(CURDIR)/include/bpf-compat			\
	     -I$(INCLUDE_DIR) -I$(APIDIR)					\
	     -I../../include							\
	     $(call get_sys_includes,$(CLANG))					\
	     -Wall -Wno-compare-distinct-pointer-types				\
	     -O2 -mcpu=v3

# sort removes libbpf duplicates when not cross-building
MAKE_DIRS := $(sort $(OBJ_DIR)/libbpf $(HOST_BUILD_DIR)/libbpf			\
	       $(HOST_BUILD_DIR)/bpftool $(HOST_BUILD_DIR)/resolve_btfids	\
	       $(INCLUDE_DIR) $(SCXOBJ_DIR) $(BINDIR))

$(MAKE_DIRS):
	$(call msg,MKDIR,,$@)
	$(Q)mkdir -p $@

ifneq ($(CROSS_COMPILE),)
$(BPFOBJ): $(wildcard $(BPFDIR)/*.[ch] $(BPFDIR)/Makefile)			\
	   $(APIDIR)/linux/bpf.h						\
	   | $(OBJ_DIR)/libbpf
	$(Q)$(MAKE) $(submake_extras) CROSS_COMPILE=$(CROSS_COMPILE) 		\
		    -C $(BPFDIR) OUTPUT=$(OBJ_DIR)/libbpf/			\
		    EXTRA_CFLAGS='-g -O0 -fPIC'					\
		    LDFLAGS="$(LDFLAGS)"					\
		    DESTDIR=$(OUTPUT_DIR) prefix= all install_headers
endif

$(HOST_BPFOBJ): $(wildcard $(BPFDIR)/*.[ch] $(BPFDIR)/Makefile)		\
	   $(APIDIR)/linux/bpf.h						\
	   | $(HOST_BUILD_DIR)/libbpf
	$(Q)$(MAKE) $(submake_extras) -C $(BPFDIR) 				\
		    OUTPUT=$(HOST_BUILD_DIR)/libbpf/				\
		    ARCH= CROSS_COMPILE= CC="$(HOSTCC)" LD=$(HOSTLD)		\
		    EXTRA_CFLAGS='-g -O0 -fPIC'					\
		    DESTDIR=$(HOST_OUTPUT_DIR) prefix= all install_headers

$(DEFAULT_BPFTOOL): $(wildcard $(BPFTOOLDIR)/*.[ch] $(BPFTOOLDIR)/Makefile)	\
		    $(HOST_BPFOBJ) | $(HOST_BUILD_DIR)/bpftool
	$(Q)$(MAKE) $(submake_extras)  -C $(BPFTOOLDIR)				\
		    ARCH= CROSS_COMPILE= CC="$(HOSTCC)" LD=$(HOSTLD)		\
		    EXTRA_CFLAGS='-g -O0'					\
		    OUTPUT=$(HOST_BUILD_DIR)/bpftool/				\
		    LIBBPF_OUTPUT=$(HOST_BUILD_DIR)/libbpf/			\
		    LIBBPF_DESTDIR=$(HOST_OUTPUT_DIR)/				\
		    prefix= DESTDIR=$(HOST_OUTPUT_DIR)/ install-bin

$(INCLUDE_DIR)/vmlinux.h: $(VMLINUX_BTF) $(BPFTOOL) | $(INCLUDE_DIR)
ifeq ($(VMLINUX_H),)
	$(call msg,GEN,,$@)
	$(Q)$(BPFTOOL) btf dump file $(VMLINUX_BTF) format c > $@
else
	$(call msg,CP,,$@)
	$(Q)cp "$(VMLINUX_H)" $@
endif

$(SCXOBJ_DIR)/%.bpf.o: %.bpf.c $(INCLUDE_DIR)/vmlinux.h include/scx/*.h		\
		       | $(BPFOBJ) $(SCXOBJ_DIR)
	$(call msg,CLNG-BPF,,$(notdir $@))
	$(Q)$(CLANG) $(BPF_CFLAGS) -target bpf -c $< -o $@

$(INCLUDE_DIR)/%.bpf.skel.h: $(SCXOBJ_DIR)/%.bpf.o $(INCLUDE_DIR)/vmlinux.h $(BPFTOOL)
	$(eval sched=$(notdir $@))
	$(call msg,GEN-SKEL,,$(sched))
	$(Q)$(BPFTOOL) gen object $(<:.o=.linked1.o) $<
	$(Q)$(BPFTOOL) gen object $(<:.o=.linked2.o) $(<:.o=.linked1.o)
	$(Q)$(BPFTOOL) gen object $(<:.o=.linked3.o) $(<:.o=.linked2.o)
	$(Q)diff $(<:.o=.linked2.o) $(<:.o=.linked3.o)
	$(Q)$(BPFTOOL) gen skeleton $(<:.o=.linked3.o) name $(subst .bpf.skel.h,,$(sched)) > $@
	$(Q)$(BPFTOOL) gen subskeleton $(<:.o=.linked3.o) name $(subst .bpf.skel.h,,$(sched)) > $(@:.skel.h=.subskel.h)

SCX_COMMON_DEPS := include/scx/common.h include/scx/user_exit_info.h | $(BINDIR)

c-sched-targets = scx_simple scx_cpu0 scx_qmap scx_central scx_flatcg

$(addprefix $(BINDIR)/,$(c-sched-targets)): \
	$(BINDIR)/%: \
		$(filter-out %.bpf.c,%.c) \
		$(INCLUDE_DIR)/%.bpf.skel.h \
		$(SCX_COMMON_DEPS)
	$(eval sched=$(notdir $@))
	$(CC) $(CFLAGS) -c $(sched).c -o $(SCXOBJ_DIR)/$(sched).o
	$(CC) -o $@ $(SCXOBJ_DIR)/$(sched).o $(BPFOBJ) $(LDFLAGS)

$(c-sched-targets): %: $(BINDIR)/%

install: all
	$(Q)mkdir -p $(DESTDIR)/usr/local/bin/
	$(Q)cp $(BINDIR)/* $(DESTDIR)/usr/local/bin/

clean:
	rm -rf $(OUTPUT_DIR) $(HOST_OUTPUT_DIR)
	rm -f *.o *.bpf.o *.bpf.skel.h *.bpf.subskel.h
	rm -f $(c-sched-targets)

help:
	@echo   'Building targets'
	@echo   '================'
	@echo   ''
	@echo   '  all		  - Compile all schedulers'
	@echo   ''
	@echo   'Alternatively, you may compile individual schedulers:'
	@echo   ''
	@printf '  %s\n' $(c-sched-targets)
	@echo   ''
	@echo   'For any scheduler build target, you may specify an alternative'
	@echo   'build output path with the O= environment variable. For example:'
	@echo   ''
	@echo   '   O=/tmp/sched_ext make all'
	@echo   ''
	@echo   'will compile all schedulers, and emit the build artifacts to'
	@echo   '/tmp/sched_ext/build.'
	@echo   ''
	@echo   ''
	@echo   'Installing targets'
	@echo   '=================='
	@echo   ''
	@echo   '  install	  - Compile and install all schedulers to /usr/bin.'
	@echo   '		    You may specify the DESTDIR= environment variable'
	@echo   '		    to indicate a prefix for /usr/bin. For example:'
	@echo   ''
	@echo   '                     DESTDIR=/tmp/sched_ext make install'
	@echo   ''
	@echo   '		    will build the schedulers in CWD/build, and'
	@echo   '		    install the schedulers to /tmp/sched_ext/usr/bin.'
	@echo   ''
	@echo   ''
	@echo   'Cleaning targets'
	@echo   '================'
	@echo   ''
	@echo   '  clean		  - Remove all generated files'

all_targets: $(c-sched-targets)

.PHONY: all all_targets $(c-sched-targets) clean help

# delete failed targets
.DELETE_ON_ERROR:

# keep intermediate (.bpf.skel.h, .bpf.o, etc) targets
.SECONDARY:

=== drivers/accel/ethosu/Makefile ===
# SPDX-License-Identifier: GPL-2.0-only

obj-$(CONFIG_DRM_ACCEL_ARM_ETHOSU) := ethosu.o
ethosu-y += ethosu_drv.o ethosu_gem.o ethosu_job.o

=== drivers/platform/arm64/Makefile ===
# SPDX-License-Identifier: GPL-2.0-only
#
# Makefile for linux/drivers/platform/arm64
#
# This dir should only include drivers for EC-like devices.
#

obj-$(CONFIG_EC_ACER_ASPIRE1)	+= acer-aspire1-ec.o
obj-$(CONFIG_EC_HUAWEI_GAOKUN)	+= huawei-gaokun-ec.o
obj-$(CONFIG_EC_LENOVO_YOGA_C630) += lenovo-yoga-c630.o
obj-$(CONFIG_EC_LENOVO_THINKPAD_T14S) += lenovo-thinkpad-t14s.o
obj-$(CONFIG_EC_LENOVO_YOGA_SLIM7X) += lenovo-yoga-slim7x.o

=== lib/raid6/test/Makefile ===
# SPDX-License-Identifier: GPL-2.0
#
# This is a simple Makefile to test some of the RAID-6 code
# from userspace.
#

pound := \#

# Adjust as desired
CC       = gcc
OPTFLAGS = -O2
CFLAGS   = -I.. -I ../../../include -g $(OPTFLAGS)
LD       = ld
AWK      = awk -f
AR       = ar
RANLIB   = ranlib
OBJS     = int1.o int2.o int4.o int8.o int16.o int32.o recov.o algos.o tables.o

ARCH := $(shell uname -m 2>/dev/null | sed -e /s/i.86/i386/)
ifeq ($(ARCH),i386)
        CFLAGS += -DCONFIG_X86_32
        IS_X86 = yes
endif
ifeq ($(ARCH),x86_64)
        CFLAGS += -DCONFIG_X86_64
        IS_X86 = yes
endif

ifeq ($(ARCH),arm)
        CFLAGS += -I../../../arch/arm/include -mfpu=neon
        HAS_NEON = yes
endif
ifeq ($(ARCH),aarch64)
        CFLAGS += -I../../../arch/arm64/include
        HAS_NEON = yes
endif

ifeq ($(findstring riscv,$(ARCH)),riscv)
        CFLAGS += -I../../../arch/riscv/include -DCONFIG_RISCV=1
        HAS_RVV = yes
endif

ifeq ($(findstring ppc,$(ARCH)),ppc)
        CFLAGS += -I../../../arch/powerpc/include
        HAS_ALTIVEC := $(shell printf '$(pound)include <altivec.h>\nvector int a;\n' |\
                         gcc -c -x c - >/dev/null && rm ./-.o && echo yes)
endif

ifeq ($(ARCH),loongarch64)
        CFLAGS += -I../../../arch/loongarch/include -DCONFIG_LOONGARCH=1
        CFLAGS += $(shell echo 'vld $$vr0, $$zero, 0' |         \
                    gcc -c -x assembler - >/dev/null 2>&1 &&    \
                    rm ./-.o && echo -DCONFIG_CPU_HAS_LSX=1)
        CFLAGS += $(shell echo 'xvld $$xr0, $$zero, 0' |        \
                    gcc -c -x assembler - >/dev/null 2>&1 &&    \
                    rm ./-.o && echo -DCONFIG_CPU_HAS_LASX=1)
endif

ifeq ($(IS_X86),yes)
        OBJS   += mmx.o sse1.o sse2.o avx2.o recov_ssse3.o recov_avx2.o avx512.o recov_avx512.o
        CFLAGS += -DCONFIG_X86
else ifeq ($(HAS_NEON),yes)
        OBJS   += neon.o neon1.o neon2.o neon4.o neon8.o recov_neon.o recov_neon_inner.o
        CFLAGS += -DCONFIG_KERNEL_MODE_NEON=1
else ifeq ($(HAS_ALTIVEC),yes)
        CFLAGS += -DCONFIG_ALTIVEC
        OBJS += altivec1.o altivec2.o altivec4.o altivec8.o \
                vpermxor1.o vpermxor2.o vpermxor4.o vpermxor8.o
else ifeq ($(ARCH),loongarch64)
        OBJS += loongarch_simd.o recov_loongarch_simd.o
else ifeq ($(HAS_RVV),yes)
        OBJS   += rvv.o recov_rvv.o
        CFLAGS += -DCONFIG_RISCV_ISA_V=1
endif

.c.o:
	$(CC) $(CFLAGS) -c -o $@ $<

%.c: ../%.c
	cp -f $< $@

%.uc: ../%.uc
	cp -f $< $@

all: raid6.a raid6test

raid6.a: $(OBJS)
	rm -f $@
	$(AR) cq $@ $^
	$(RANLIB) $@

raid6test: test.c raid6.a
	$(CC) $(CFLAGS) -o raid6test $^

neon1.c: neon.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=1 < neon.uc > $@

neon2.c: neon.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=2 < neon.uc > $@

neon4.c: neon.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=4 < neon.uc > $@

neon8.c: neon.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=8 < neon.uc > $@

altivec1.c: altivec.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=1 < altivec.uc > $@

altivec2.c: altivec.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=2 < altivec.uc > $@

altivec4.c: altivec.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=4 < altivec.uc > $@

altivec8.c: altivec.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=8 < altivec.uc > $@

vpermxor1.c: vpermxor.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=1 < vpermxor.uc > $@

vpermxor2.c: vpermxor.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=2 < vpermxor.uc > $@

vpermxor4.c: vpermxor.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=4 < vpermxor.uc > $@

vpermxor8.c: vpermxor.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=8 < vpermxor.uc > $@

int1.c: int.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=1 < int.uc > $@

int2.c: int.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=2 < int.uc > $@

int4.c: int.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=4 < int.uc > $@

int8.c: int.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=8 < int.uc > $@

int16.c: int.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=16 < int.uc > $@

int32.c: int.uc ../unroll.awk
	$(AWK) ../unroll.awk -vN=32 < int.uc > $@

tables.c: mktables
	./mktables > tables.c

clean:
	rm -f *.o *.a mktables mktables.c *.uc int*.c altivec*.c vpermxor*.c neon*.c tables.c raid6test

spotless: clean
	rm -f *~

=== tools/net/ynl/Makefile ===
# SPDX-License-Identifier: GPL-2.0

include ../../scripts/Makefile.arch

INSTALL	?= install
prefix  ?= /usr
ifeq ($(LP64), 1)
  libdir_relative = lib64
else
  libdir_relative = lib
endif
libdir  ?= $(prefix)/$(libdir_relative)
includedir ?= $(prefix)/include

SPECDIR=../../../Documentation/netlink/specs

SUBDIRS = lib generated samples ynltool tests

all: $(SUBDIRS) libynl.a

ynltool: | lib generated libynl.a
samples: | lib generated
libynl.a: | lib generated
	@echo -e "\tAR $@"
	@ar rcs $@ lib/ynl.o generated/*-user.o

$(SUBDIRS):
	@if [ -f "$@/Makefile" ] ; then \
		$(MAKE) -C $@ ; \
	fi

clean distclean:
	@for dir in $(SUBDIRS) ; do \
		if [ -f "$$dir/Makefile" ] ; then \
			$(MAKE) -C $$dir $@; \
		fi \
	done
	rm -f libynl.a
	rm -rf pyynl/__pycache__
	rm -rf pyynl/lib/__pycache__
	rm -rf pyynl.egg-info
	rm -rf build

install: libynl.a lib/*.h
	@echo -e "\tINSTALL libynl.a"
	@$(INSTALL) -d $(DESTDIR)$(libdir)
	@$(INSTALL) -m 0644 libynl.a $(DESTDIR)$(libdir)/libynl.a
	@echo -e "\tINSTALL libynl headers"
	@$(INSTALL) -d $(DESTDIR)$(includedir)/ynl
	@$(INSTALL) -m 0644 lib/*.h $(DESTDIR)$(includedir)/ynl/
	@echo -e "\tINSTALL pyynl"
	@pip install --prefix=$(DESTDIR)$(prefix) .
	@make -C generated install

run_tests:
	@$(MAKE) -C tests run_tests

lint:
	yamllint $(SPECDIR)

schema_check:
	@N=1; \
	for spec in $(SPECDIR)/*.yaml ; do \
		NAME=$$(basename $$spec) ; \
		OUTPUT=$$(./pyynl/cli.py --spec $$spec --validate) ; \
		if [ $$? -eq 0 ] ; then \
			echo "ok $$N $$NAME schema validation" ; \
		else \
			echo "not ok $$N $$NAME schema validation" ; \
			echo "$$OUTPUT" ; \
			echo ; \
		fi ; \
		N=$$((N+1)) ; \
	done

.PHONY: all clean distclean install run_tests lint schema_check $(SUBDIRS)

=== tools/testing/selftests/net/Makefile ===
# SPDX-License-Identifier: GPL-2.0
# Makefile for net selftests

CFLAGS += -Wall -Wl,--no-as-needed -O2 -g
CFLAGS += -I../../../../usr/include/ $(KHDR_INCLUDES)
# Additional include paths needed by kselftest.h
CFLAGS += -I../

TEST_PROGS := \
	altnames.sh \
	amt.sh \
	arp_ndisc_evict_nocarrier.sh \
	arp_ndisc_untracked_subnets.sh \
	bareudp.sh \
	big_tcp.sh \
	bind_bhash.sh \
	bpf_offload.py \
	broadcast_ether_dst.sh \
	broadcast_pmtu.sh \
	busy_poll_test.sh \
	cmsg_ip.sh \
	cmsg_so_mark.sh \
	cmsg_so_priority.sh \
	cmsg_time.sh \
	drop_monitor_tests.sh \
	fcnal-ipv4.sh \
	fcnal-ipv6.sh \
	fcnal-other.sh \
	fdb_flush.sh \
	fdb_notify.sh \
	fib-onlink-tests.sh \
	fib_nexthop_multiprefix.sh \
	fib_nexthop_nongw.sh \
	fib_nexthops.sh \
	fib_rule_tests.sh \
	fib_tests.sh \
	fin_ack_lat.sh \
	fq_band_pktlimit.sh \
	gre_gso.sh \
	gre_ipv6_lladdr.sh \
	icmp.sh \
	icmp_redirect.sh \
	io_uring_zerocopy_tx.sh \
	ioam6.sh \
	ip6_gre_headroom.sh \
	ip_defrag.sh \
	ip_local_port_range.sh \
	ipv6_flowlabel.sh \
	ipv6_force_forwarding.sh \
	ipv6_route_update_soft_lockup.sh \
	l2_tos_ttl_inherit.sh \
	l2tp.sh \
	link_netns.py \
	lwt_dst_cache_ref_loop.sh \
	msg_zerocopy.sh \
	nat6to4.sh \
	ndisc_unsolicited_na_test.sh \
	netdev-l2addr.sh \
	netdevice.sh \
	netns-name.sh \
	netns-sysctl.sh \
	nl_netdev.py \
	pmtu.sh \
	psock_snd.sh \
	reuseaddr_ports_exhausted.sh \
	reuseport_addr_any.sh \
	route_hint.sh \
	route_localnet.sh \
	rps_default_mask.sh \
	rtnetlink.py \
	rtnetlink.sh \
	rtnetlink_notification.sh \
	run_afpackettests \
	run_netsocktests \
	rxtimestamp.sh \
	sctp_vrf.sh \
	skf_net_off.sh \
	so_txtime.sh \
	srv6_end_dt46_l3vpn_test.sh \
	srv6_end_dt4_l3vpn_test.sh \
	srv6_end_dt6_l3vpn_test.sh \
	srv6_end_dx4_netfilter_test.sh \
	srv6_end_dx6_netfilter_test.sh \
	srv6_end_flavors_test.sh \
	srv6_end_next_csid_l3vpn_test.sh \
	srv6_end_x_next_csid_l3vpn_test.sh \
	srv6_hencap_red_l3vpn_test.sh \
	srv6_hl2encap_red_l2vpn_test.sh \
	stress_reuseport_listen.sh \
	tcp_fastopen_backup_key.sh \
	test_bpf.sh \
	test_bridge_backup_port.sh \
	test_bridge_neigh_suppress.sh \
	test_ingress_egress_chaining.sh \
	test_neigh.sh \
	test_so_rcv.sh \
	test_vxlan_fdb_changelink.sh \
	test_vxlan_mdb.sh \
	test_vxlan_nh.sh \
	test_vxlan_nolocalbypass.sh \
	test_vxlan_under_vrf.sh \
	test_vxlan_vnifiltering.sh \
	tfo_passive.sh \
	traceroute.sh \
	txtimestamp.sh \
	udpgro.sh \
	udpgro_bench.sh \
	udpgro_frglist.sh \
	udpgro_fwd.sh \
	udpgso.sh \
	udpgso_bench.sh \
	unicast_extensions.sh \
	veth.sh \
	vlan_bridge_binding.sh \
	vlan_hw_filter.sh \
	vrf-xfrm-tests.sh \
	vrf_route_leaking.sh \
	vrf_strict_mode_test.sh \
	xfrm_policy.sh \
# end of TEST_PROGS

TEST_PROGS_EXTENDED := \
	xfrm_policy_add_speed.sh \
# end of TEST_PROGS_EXTENDED

TEST_GEN_FILES := \
	bind_bhash \
	cmsg_sender \
	fin_ack_lat \
	hwtstamp_config \
	io_uring_zerocopy_tx \
	ioam6_parser \
	ip_defrag \
	ip_local_port_range \
	ipsec \
	ipv6_flowlabel \
	ipv6_flowlabel_mgr \
	msg_zerocopy \
	nettest \
	psock_fanout \
	psock_snd \
	psock_tpacket \
	reuseaddr_ports_exhausted \
	reuseport_addr_any \
	rxtimestamp \
	sctp_hello \
	skf_net_off \
	so_netns_cookie \
	so_rcv_listener \
	so_txtime \
	socket \
	stress_reuseport_listen \
	tcp_fastopen_backup_key \
	tcp_inq \
	tcp_mmap \
	tfo \
	timestamping \
	txring_overwrite \
	txtimestamp \
	udpgso \
	udpgso_bench_rx \
	udpgso_bench_tx \
# end of TEST_GEN_FILES

TEST_GEN_PROGS := \
	bind_timewait \
	bind_wildcard \
	epoll_busy_poll \
	ipv6_fragmentation \
	proc_net_pktgen \
	reuseaddr_conflict \
	reuseport_bpf \
	reuseport_bpf_cpu \
	reuseport_bpf_numa \
	reuseport_dualstack \
	sk_bind_sendto_listen \
	sk_connect_zero_addr \
	sk_so_peek_off \
	so_incoming_cpu \
	tap \
	tcp_port_share \
	tls \
	tun \
# end of TEST_GEN_PROGS

TEST_FILES := \
	fcnal-test.sh \
	in_netns.sh \
	lib.sh \
	settings \
# end of TEST_FILES

# YNL files, must be before "include ..lib.mk"
YNL_GEN_FILES := busy_poller
YNL_GEN_PROGS := netlink-dumps
TEST_GEN_FILES += $(YNL_GEN_FILES)
TEST_GEN_PROGS += $(YNL_GEN_PROGS)

TEST_GEN_FILES += $(patsubst %.c,%.o,$(wildcard *.bpf.c))

TEST_INCLUDES := forwarding/lib.sh

include ../lib.mk

# YNL build
YNL_GENS := netdev
include ynl.mk

$(OUTPUT)/epoll_busy_poll: LDLIBS += -lcap
$(OUTPUT)/reuseport_bpf_numa: LDLIBS += -lnuma
$(OUTPUT)/tcp_mmap: LDLIBS += -lpthread -lcrypto
$(OUTPUT)/tcp_inq: LDLIBS += -lpthread
$(OUTPUT)/bind_bhash: LDLIBS += -lpthread
$(OUTPUT)/io_uring_zerocopy_tx: CFLAGS += -I../../../include/

include bpf.mk

=== tools/testing/selftests/ublk/Makefile ===
# SPDX-License-Identifier: GPL-2.0

CFLAGS += -O3 -Wl,-no-as-needed -Wall -I $(top_srcdir)/usr/include
ifneq ($(WERROR),0)
	CFLAGS += -Werror
endif

LDLIBS += -lpthread -lm -luring

TEST_PROGS := test_generic_01.sh
TEST_PROGS += test_generic_02.sh
TEST_PROGS += test_generic_03.sh
TEST_PROGS += test_generic_04.sh
TEST_PROGS += test_generic_05.sh
TEST_PROGS += test_generic_06.sh
TEST_PROGS += test_generic_07.sh

TEST_PROGS += test_generic_08.sh
TEST_PROGS += test_generic_09.sh
TEST_PROGS += test_generic_10.sh
TEST_PROGS += test_generic_11.sh
TEST_PROGS += test_generic_12.sh
TEST_PROGS += test_generic_13.sh
TEST_PROGS += test_generic_14.sh
TEST_PROGS += test_generic_15.sh

TEST_PROGS += test_null_01.sh
TEST_PROGS += test_null_02.sh
TEST_PROGS += test_null_03.sh
TEST_PROGS += test_loop_01.sh
TEST_PROGS += test_loop_02.sh
TEST_PROGS += test_loop_03.sh
TEST_PROGS += test_loop_04.sh
TEST_PROGS += test_loop_05.sh
TEST_PROGS += test_loop_06.sh
TEST_PROGS += test_loop_07.sh
TEST_PROGS += test_stripe_01.sh
TEST_PROGS += test_stripe_02.sh
TEST_PROGS += test_stripe_03.sh
TEST_PROGS += test_stripe_04.sh
TEST_PROGS += test_stripe_05.sh
TEST_PROGS += test_stripe_06.sh

TEST_PROGS += test_stress_01.sh
TEST_PROGS += test_stress_02.sh
TEST_PROGS += test_stress_03.sh
TEST_PROGS += test_stress_04.sh
TEST_PROGS += test_stress_05.sh
TEST_PROGS += test_stress_06.sh
TEST_PROGS += test_stress_07.sh

TEST_GEN_PROGS_EXTENDED = kublk

LOCAL_HDRS += $(wildcard *.h)
include ../lib.mk

$(TEST_GEN_PROGS_EXTENDED): $(wildcard *.c)

check:
	shellcheck -x -f gcc *.sh

=== debian/changelog ===
linux-gcp (6.19.0-1001.1) resolute; urgency=medium

  * resolute/linux-gcp: 6.19.0-1001.1 -proposed tracker (LP: #2139184)

  * Packaging resync (LP: #1786013)
    - [Packaging] gcp: Remove dwarfdump from Build-Depends
    - [Packaging] update variants
    - [Packaging] update update.conf
    - [Packaging] update Ubuntu.md
    - [Packaging] debian.gcp/dkms-versions -- update from kernel-versions
      (main/d2025.09.29)

  * [UBUNTU 24.04] IOMMU DMA mode changed in kernel config causes massive
    throughput degradation for PCI-related network workloads (LP: #2071471) //
    NVIDIA Grace update for Google (Sep 2025) (LP: #2126453)
    - [Packaging] gcp: disable CONFIG_IOMMU_DEFAULT_DMA_STRICT enable
      CONFIG_IOMMU_DEFAULT_DMA_LAZY

  * Miscellaneous Ubuntu changes
    - [Config] updateconfigs after rebase to 6.19-rc6

  [ Ubuntu: 6.19.0-3.3 ]

  * resolute/linux: 6.19.0-3.3 -proposed tracker (LP: #2138935)
  * Packaging resync (LP: #1786013)
    - [Packaging] debian.master/dkms-versions -- update from kernel-versions
      (main/d2026.01.12)
    - [Packaging] update variants
  * [26.04] Please test secureboot and lock-down with 6.18 kernel (s390x) on
    Resolute Raccoon (LP: #2131805)
    - SAUCE: s390/boot/vmlinux.lds.S: Ensure bzImage ends with SecureBoot
      trailer
  * unconfined profile denies userns_create for chromium based processes
    - [Config] disable CONFIG_SECURITY_APPARMOR_RESTRICT_USERNS
  * update apparmor and LSM stacking patch set
    - SAUCE: apparmor5.0.0 [1/53]: Stacking: LSM: Single calls in secid hooks
    - SAUCE: apparmor5.0.0 [2/53]: Stacking: LSM: Exclusive secmark usage
    - SAUCE: apparmor5.0.0 [3/53]: Stacking: Audit: Call only the first of the
      audit rule hooks
    - SAUCE: apparmor5.0.0 [4/53]: Stacking: AppArmor: Remove the exclusive
      flag
    - SAUCE: apparmor5.0.0 [5/53]: apparmor-next 7.0: apparmor: replace
      sprintf with snprintf in aa_new_learning_profile
    - SAUCE: apparmor5.0.0 [6/53]: apparmor-next 7.0: apparmor: Replace
      sprintf/strcpy with scnprintf/strscpy in aa_policy_init
    - SAUCE: apparmor5.0.0 [7/53]: apparmor-next 7.0: apparmor: Replace
      deprecated strcpy in d_namespace_path
    - SAUCE: apparmor5.0.0 [8/53]: apparmor-next 7.0: apparmor: fix NULL
      pointer dereference in __unix_needs_revalidation
    - SAUCE: apparmor5.0.0 [9/53]: apparmor-next 7.0: apparmor: fix NULL sock
      in aa_sock_file_perm
    - SAUCE: apparmor5.0.0 [10/53]: apparmor-next 7.0: apparmor: Replace
      deprecated strcpy with memcpy in gen_symlink_name
    - SAUCE: apparmor5.0.0 [11/53]: apparmor-next 7.0: AppArmor: Allow
      apparmor to handle unaligned dfa tables
    - SAUCE: apparmor5.0.0 [12/53]: apparmor-next 7.0: apparmor: Fix &
      Optimize table creation from possibly unaligned memory
    - SAUCE: apparmor5.0.0 [13/53]: apparmor-next 7.0: apparmor: make str
      table more generic and be able to have multiple entries
    - SAUCE: apparmor5.0.0 [14/53]: apparmor-next 7.0: apparmor: add support
      loading per permission tagging
    - SAUCE: apparmor5.0.0 [15/53]: apparmor-next 7.0: aoparmor: userns: Add
      support for execpath in userns
    - SAUCE: apparmor5.0.0 [16/53]: apparmor-next 7.0: apparmor: fix boolean
      argument in apparmor_mmap_file
    - SAUCE: apparmor5.0.0 [17/53]: apparmor-next 7.0: apparmor: drop
      in_atomic flag in common_mmap, and common_file_perm
    - SAUCE: apparmor5.0.0 [18/53]: apparmor-next 7.0: apparmor: account for
      in_atomic removal in common_file_perm
    - SAUCE: apparmor5.0.0 [19/53]: apparmor-next 7.0: apparmor: return
      -ENOMEM in unpack_perms_table upon alloc failure
    - SAUCE: apparmor5.0.0 [20/53]: apparmor-next 7.0: apparmor: guard against
      free routines being called with a NULL
    - SAUCE: apparmor5.0.0 [21/53]: apparmor-next 7.0: apparmor: move check
      for aa_null file to cover all cases
    - SAUCE: apparmor5.0.0 [22/53]: apparmor-next 7.0: apparmor: fix label and
      profile debug macros
    - SAUCE: apparmor5.0.0 [23/53]: apparmor-next 7.0: apparmor:
      refactor/cleanup cred helper fns.
    - SAUCE: apparmor5.0.0 [24/53]: apparmor-next 7.0: apparmor: fix rlimit
      for posix cpu timers
    - SAUCE: apparmor5.0.0 [25/53]: apparmor-next 7.0: apparmor: fix fast path
      cache check for unix sockets
    - SAUCE: apparmor5.0.0 [26/53]: apparmor-next 7.0: apparmor: remove
      apply_modes_to_perms from label_match
    - SAUCE: apparmor5.0.0 [27/53]: apparmor-next 7.0: apparmor: make
      label_match return a consistent value
    - SAUCE: apparmor5.0.0 [28/53]: apparmor-next 7.0: apparmor: split
      xxx_in_ns into its two separate semantic use cases
    - SAUCE: apparmor5.0.0 [29/53]: apparmor-next 7.0: apparmor: avoid per-cpu
      hold underflow in aa_get_buffer
    - SAUCE: apparmor5.0.0 [30/53]: Revert "apparmor: fix dbus permission
      queries to v9 ABI"
    - SAUCE: apparmor5.0.0 [31/53]: Revert "apparmor: gate make fine grained
      unix mediation behind v9 abi"
    - SAUCE: apparmor5.0.0 [32/53]: apparmor: net: patch to provide
      compatibility with v2.x net rules
    - SAUCE: apparmor5.0.0 [33/53]: apparmor: net: add fine grained ipv4/ipv6
      mediation
    - SAUCE: apparmor5.0.0 [34/53]: apparmor: lift compatibility check out of
      profile_af_perm
    - SAUCE: apparmor5.0.0 [35/53]: apparmor: userns: add unprivileged user ns
      mediation
    - SAUCE: apparmor5.0.0 [36/53]: apparmor: userns: Add sysctls for
      additional controls of unpriv userns restrictions
    - SAUCE: apparmor5.0.0 [37/53]: apparmor: userns - make it so special
      unconfined profiles can mediate user namespaces
    - SAUCE: apparmor5.0.0 [38/53]: apparmor: userns: open userns related
      sysctl so lxc can check if restriction are in place
    - SAUCE: apparmor5.0.0 [39/53]: apparmor: userns: allow profile to be
      transitioned when a userns is created
    - SAUCE: apparmor5.0.0 [40/53]: apparmor: mqueue: call


=== debian/control ===
Source: linux-gcp
Section: devel
Priority: optional
Maintainer: Ubuntu Kernel Team <kernel-team@lists.ubuntu.com>
XSC-Ubuntu-Compatible-Signing: ubuntu/4 pro/3
Rules-Requires-Root: no
Standards-Version: 3.9.4.0
Build-Depends:
 gcc:native, gcc-aarch64-linux-gnu [arm64] <cross>, gcc-arm-linux-gnueabihf [armhf] <cross>, gcc-powerpc64le-linux-gnu [ppc64el] <cross>, gcc-riscv64-linux-gnu [riscv64] <cross>, gcc-s390x-linux-gnu [s390x] <cross>, gcc-x86-64-linux-gnu [amd64] <cross>,
 debhelper-compat (= 10),
 cpio,
 kmod <!stage1>,
 makedumpfile [amd64] <!stage1>,
 libcap-dev <!stage1>,
 libelf-dev <!stage1>,
 libnewt-dev <!stage1>,
 libiberty-dev <!stage1>,
 default-jdk-headless <!stage1>,
 java-common <!stage1>,
 rsync [!i386] <!stage1>,
 libdw-dev <!stage1>,
 libpci-dev <!stage1>,
 pkg-config <!stage1>,
 python3 <!stage1>,
 python3-dev <!stage1>,
 python3-setuptools,
 flex <!stage1>,
 bison <!stage1>,
 libunwind8-dev [amd64 arm64 armhf ppc64el] <!stage1>,
 liblzma-dev <!stage1>,
 openssl <!stage1>,
 libssl-dev <!stage1>,
 libaudit-dev <!stage1>,
 bc <!stage1>,
 gawk <!stage1>,
 libudev-dev <!stage1>,
 autoconf <!stage1>,
 automake <!stage1>,
 libtool <!stage1>,
 uuid-dev <!stage1>,
 libnuma-dev [amd64 arm64 ppc64el s390x] <!stage1>,
 libtraceevent-dev [amd64 arm64 armhf ppc64el s390x riscv64] <!stage1>,
 libtracefs-dev [amd64 arm64 armhf ppc64el s390x riscv64] <!stage1>,
 dkms <!stage1>,
 curl <!stage1>,
 zstd <!stage1>,
 pahole (>= 1.29-2ubuntu2) [amd64 arm64 armhf ppc64el s390x riscv64] | dwarves (>= 1.21) [amd64 arm64 armhf ppc64el s390x riscv64] <!stage1>,
 clang-18 [amd64 arm64 armhf ppc64el riscv64 s390x],
 rustc [amd64 arm64 armhf ppc64el riscv64 s390x],
 rust-src [amd64 arm64 armhf ppc64el riscv64 s390x],
 rustfmt [amd64 arm64 armhf ppc64el riscv64 s390x],
 bindgen [amd64 arm64 armhf ppc64el riscv64 s390x],
 libstdc++-dev,
Build-Depends-Indep:
 xmlto <!stage1>,
 bzip2 <!stage1>,
 sharutils <!stage1>,
 asciidoc <!stage1>,
 python3-docutils <!stage1>,
Vcs-Git: git://git.launchpad.net/~canonical-kernel/ubuntu/+source/linux-gcp/+git/resolute
XS-Testsuite: autopkgtest
#XS-Testsuite-Depends: gcc-4.7 binutils

Package: linux-gcp-headers-6.19.0-1001
Build-Profiles: <!stage1>
Architecture: amd64 arm64
Multi-Arch: foreign
Section: devel
Priority: optional
Depends: ${misc:Depends}, coreutils
Breaks: iscsitarget-dkms (<< 1.4.20.3+svn502-2ubuntu4.4)
Description: Header files related to Linux kernel version 6.19.0
 This package provides kernel header files for version 6.19.0, for sites
 that want the latest kernel headers. Please read
 /usr/share/doc/linux-gcp-headers-6.19.0-1001/debian.README.gz for details

Package: linux-gcp-tools-6.19.0-1001
Build-Profiles: <!stage1>
Architecture: amd64 arm64
Section: devel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}, linux-tools-common
Description: Linux kernel version specific tools for version 6.19.0-1001
 This package provides the architecture dependant parts for kernel
 version locked tools (such as perf and x86_energy_perf_policy) for
 version 6.19.0-1001.
 You probably want to install linux-tools-6.19.0-1001-<flavour>.

Package: linux-image-unsigned-6.19.0-1001-gcp
Build-Profiles: <!stage1>
Architecture: amd64 arm64
Section: kernel
Priority: optional
Provides: linux-image, fuse-module, ${linux:rprovides}
Depends: ${misc:Depends}, ${shlibs:Depends}, kmod, linux-base (>= 4.5ubuntu1~16.04.1), linux-modules-6.19.0-1001-gcp
Recommends: grub-pc | grub-efi-amd64 | grub-efi-ia32 | grub | lilo | grub-efi-arm64 [arm64]
Breaks: flash-kernel (<< 3.90ubuntu2) [arm64 armhf], s390-tools (<< 2.3.0-0ubuntu3) [s390x]
Conflicts: linux-image-6.19.0-1001-gcp
Suggests: bpftool, linux-perf, linux-gcp-tools, linux-headers-6.19.0-1001-gcp, linux-modules-extra-6.19.0-1001-gcp
Description: Linux kernel image for version 6.19.0
 This package contains the unsigned Linux kernel image for version 6.19.0.
 .
 Supports amd64 processors.
 .
 Geared toward GCP or GKE systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-gcp meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.

Package: linux-image-unsigned-6.19.0-1001-gcp-dbgsym
Build-Profiles: <!stage1>
Architecture: amd64 arm64
Section: devel
Priority: optional
Depends: ${misc:Depends}
Provides: linux-debug
Description: Linux kernel debug image for version 6.19.0
 This package provides the unsigned kernel debug image for version 6.19.0.
 .
 This is for sites that wish to debug the kernel.
 .
 The kernel image contained in this package is NOT meant to boot from. It
 is uncompressed, and unstripped. This package also includes the
 unstripped modules.


Package: linux-modules-6.19.0-1001-gcp
Build-Profiles: <!stage1>
Architecture: amd64 arm64
Section: kernel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${linux:BuiltUsing}
Description: Linux kernel extra modules for version 6.19.0
 Contains the corresponding System.map file, the modules built by the
 packager, and scripts that try to ensure that the system is not left in an
 unbootable state after an update.
 .
 Supports amd64 processors.
 .
 Geared toward GCP or GKE systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-gcp meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.

Package: linux-modules-extra-6.19.0-1001-gcp
Build-Profiles: <!stage1>
Architecture: amd64 arm64
Section: kernel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}, wireless-regdb, linux-modules-6.19.0-1001-gcp
Description: Linux kernel extra modules for version 6.19.0
 This package contains the Linux kernel extra modules for version 6.19.0.
 .
 Also includes the corresponding System.map file, the modules built by the
 packager, and scripts that try to ensure that the system is not left in an
 unbootable state after an update.
 .
 Supports amd64 processors.
 .
 Geared toward GCP or GKE systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-gcp meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.

Package: linux-headers-6.19.0-1001-gcp
Build-Profiles: <!stage1>
Architecture: amd64 arm64
Section: devel
Priority: optional
Depends: ${misc:Depends}, linux-gcp-headers-6.19.0-1001, ${shlibs:Depends}
Provides: linux-headers, linux-headers-3.0
Description: Linux kernel headers for version 6.19.0
 This package provides kernel header files for version 6.19.0.
 .
 This is for sites that want the latest kernel headers.  Please read
 /usr/share/doc/linux-headers-6.19.0-1001/debian.README.gz for details.

Package: linux-tools-6.19.0-1001-gcp
Build-Profiles: <!stage1>
Architecture: amd64 arm64
Section: devel
Priority: optional
Depends: ${misc:Depends}, linux-gcp-tools-6.19.0-1001
Description: Linux kernel version specific tools for version 6.19.0-1001
 This package provides the architecture dependant parts for kernel
 version locked tools (such as x86_energy_perf_policy) for
 version 6.19.0-1001.


Package: linux-buildinfo-6.19.0-1001-gcp
Build-Profiles: <!stage1>
Architecture: amd64 arm64
Section: kernel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${linux:BuiltUsing}
Description: Linux kernel buildinfo for version 6.19.0
 This package contains the Linux kernel buildinfo for version 6.19.0.
 .
 You likely do not want to install this package.

Package: linux-image-unsigned-6.19.0-1001-gcp-64k
Build-Profiles: <!stage1>
Architecture: arm64
Section: kernel
Priority: optional
Provides: linux-image, fuse-module, ${linux:rprovides}
Depends: ${misc:Depends}, ${shlibs:Depends}, kmod, linux-base (>= 4.5ubuntu1~16.04.1), linux-modules-6.19.0-1001-gcp-64k
Recommends: grub-pc | grub-efi-amd64 | grub-efi-ia32 | grub | lilo | grub-efi-arm64 [arm64]
Breaks: flash-kernel (<< 3.90ubuntu2) [arm64 armhf], s390-tools (<< 2.3.0-0ubuntu3) [s390x]
Conflicts: linux-image-6.19.0-1001-gcp-64k
Suggests: bpftool, linux-perf, linux-gcp-tools, linux-headers-6.19.0-1001-gcp-64k, linux-modules-extra-6.19.0-1001-gcp-64k
Description: Linux kernel image for version 6.19.0
 This package contains the unsigned Linux kernel image for version 6.19.0.
 .
 Supports arm64 processors.
 .
 Geared toward GCP or GKE systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-gcp-64k meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.

Package: linux-image-unsigned-6.19.0-1001-gcp-64k-dbgsym
Build-Profiles: <!stage1>
Architecture: arm64
Section: devel
Priority: optional
Depends: ${misc:Depends}
Provides: linux-debug
Description: Linux kernel debug image for version 6.19.0
 This package provides the unsigned kernel debug image for version 6.19.0.
 .
 This is for sites that wish to debug the kernel.
 .
 The kernel image contained in this package is NOT meant to boot from. It
 is uncompressed, and unstripped. This package also includes the
 unstripped modules.


Package: linux-modules-6.19.0-1001-gcp-64k
Build-Profiles: <!stage1>
Architecture: arm64
Section: kernel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${linux:BuiltUsing}
Description: Linux kernel extra modules for version 6.19.0
 Contains the corresponding System.map file, the modules built by the
 packager, and scripts that try to ensure that the system is not left in an
 unbootable state after an update.
 .
 Supports arm64 processors.
 .
 Geared toward GCP or GKE systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-gcp-64k meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.

Package: linux-modules-extra-6.19.0-1001-gcp-64k
Build-Profiles: <!stage1>
Architecture: arm64
Section: kernel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}, wireless-regdb, linux-modules-6.19.0-1001-gcp-64k
Description: Linux kernel extra modules for version 6.19.0
 This package contains the Linux kernel extra modules for version 6.19.0.
 .
 Also includes the corresponding System.map file, the modules built by the
 packager, and scripts that try to ensure that the system is not left in an
 unbootable state after an update.
 .
 Supports arm64 processors.
 .
 Geared toward GCP or GKE systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-gcp-64k meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.

Package: linux-headers-6.19.0-1001-gcp-64k
Build-Profiles: <!stage1>
Architecture: arm64
Section: devel
Priority: optional
Depends: ${misc:Depends}, linux-gcp-headers-6.19.0-1001, ${shlibs:Depends}
Provides: linux-headers, linux-headers-3.0
Description: Linux kernel headers for version 6.19.0
 This package provides kernel header files for version 6.19.0.
 .
 This is for sites that want the latest kernel headers.  Please read
 /usr/share/doc/linux-headers-6.19.0-1001/debian.README.gz for details.

Package: linux-tools-6.19.0-1001-gcp-64k
Build-Profiles: <!stage1>
Architecture: arm64
Section: devel
Priority: optional
Depends: ${misc:Depends}, linux-gcp-tools-6.19.0-1001
Description: Linux kernel version specific tools for version 6.19.0-1001
 This package provides the architecture dependant parts for kernel
 version locked tools (such as x86_energy_perf_policy) for
 version 6.19.0-1001.


Package: linux-buildinfo-6.19.0-1001-gcp-64k
Build-Profiles: <!stage1>
Architecture: arm64
Section: kernel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${linux:BuiltUsing}
Description: Linux kernel buildinfo for version 6.19.0
 This package contains the Linux kernel buildinfo for version 6.19.0.
 .
 You likely do not want to install this package.
